#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/68_PYT/m04__Volání_funkcí.pyy
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
4  Volání funkcí.

Co se v kapitole naučíte
Tato kapitola vám vysvětlí, jak se volají funkce, a představí vám
vestavěné funkce pracující s jednoduchými čísly a stringy.
Poté vás naučí využívat nápovědu a v závěru vám ukáže,
jak rozdělit volání funkce do více řádků.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
############################################################################



#Kapitola 4.2.2: Přehled vestavěných funkcí s argumenty jednoduchých typů
############################################################################

abs(-3.14)
# 3.14
abs(1+1j)     #Absolutní hodnotou komplexního čísla je jeho velikost
# 1.4142135623730951

#---------------------------------------------------------------------------

bin(5)
# '0b101'
bin(-10)
# '-0b1010'

#---------------------------------------------------------------------------

complex(), complex(0), complex(1), complex(1,2), complex(imag=3)
# (0j, 0j, (1+0j), (1+2j), 3j)

#---------------------------------------------------------------------------

float()
# 0.0
#!# float("Číslo 3.5")
# Traceback (most recent call last):
#   File "<pyshell#5>", line 1, in <module>
#     float("Číslo 3.5")
# ValueError: could not convert string to float: 'Číslo 3.5'
float('   -3.5\n')
# -3.5

#---------------------------------------------------------------------------

hex(8364)
# '0x20ac'

#---------------------------------------------------------------------------

chr(0x20ac)   #Aby se znak zobrazil, musí být definován v použitém fontu
# '€'
chr(0x1D120)  #Houslový klíč není v použitém fontu => zobrazil se jako kód
# '\U0001d120'

#---------------------------------------------------------------------------

input("Zadej číslo: ")
# Zadej číslo: 123
# '123'

#---------------------------------------------------------------------------

int(3.9)   #Při převodu se nezaokrouhluje, ale usekává se desetinná část
# 3
int (-3.9) #Stejně je tomu i při převodu záporného čísla
# -3

#---------------------------------------------------------------------------

int('1010', 2)
# 10
int('1010', 16)
# 4112
int('No_nazdar', 36)
# 1856027718675

#---------------------------------------------------------------------------

len("")
# 0
len('12345')
# 5

#---------------------------------------------------------------------------

max(1, 7, 3)
# 7
min("Jenda", 'Franta', """Lojza""")
# 'Franta'

#---------------------------------------------------------------------------

oct(255)
# '0o377'

#---------------------------------------------------------------------------

print('Hodnoty různých typů: ', 1, True, (3+1j), None)
# Hodnoty různých typů:  1 True (3+1j) None
print('Následuje:\tTabulátor\nNový řádek\rNávrat vozíku')
# Následuje:	Tabulátor
# Nový řádek Návrat vozíku

#---------------------------------------------------------------------------

round (0.5), round(1,5), round(2.5), round(3.5)   # Poloviny zaokrouhluje na sudý konec
# (0, 2, 2, 4)
round (.25,1), round(.75,1), round(.125, 2), round(.375, 2) # Totéž o řád níž
# (0.2, 0.8, 0.12, 0.38)
round(1.23456, 3), round(987.654321, 2)  # Na 3 a na 2 desetinná místa
# (1.235, 987.65)
round(987.654321, -2)  # Zaokrouhlujeme na stovky (10^2)
# 1000.0
round(3, 2), round(3, -2)   # Celé číslo zůstane po zaokrouhlení celé
# (3, 0)
round(2.675, 2)  # Číslo je ve dvojkové soustavě nepatrně menší => dolů
# 2.67

#---------------------------------------------------------------------------

repr('string'), repr("string"), repr("""string""")
# ("'string'", "'string'", "'string'")
str('string'), str("string"), str("""string""")
# ('string', 'string', 'string')
print(repr('string'), repr("string"), repr("""string"""))
# 'string' 'string' 'string'
print(str('string'), str("string"), str("""string"""))
# string string string



##### Kapitola 4.3.1  Získání nápovědy — Argument zadán
############################################################################

help(abs)
# Help on built-in function abs in module builtins:
#
# abs(x, /)
#     Return the absolute value of the argument.



#Výpis 4.1:	Zadání argumentu nápovědy pomocí stringu
############################################################################
#!# help(not)  # Nekorektní použití operátoru not vyvolá syntaktickou chybu
# SyntaxError: invalid syntax
help('not')  # Název operátoru je třeba zadat jako text
# Boolean operations
# ******************
#
#    or_test  ::= and_test | or_test "or" and_test
#    and_test ::= not_test | and_test "and" not_test
#    not_test ::= comparison | "not" not_test
#
# In the context of Boolean operations, and also when expressions are
# ...    # a dalších 27 řádků výkladu
# >>>



#Výpis 4.2:	Přepnutí do režimu nápovědy a zpět
############################################################################
help()     # Všimněte si, že bez argumentů neznamená bez závorek
#
# Welcome to Python 3.7's help utility!
#
# If this is your first time using Python, you should definitely check out
# the tutorial on the Internet at https://docs.python.org/3.7/tutorial/.
#
# Enter the name of any module, keyword, or topic to get help on writing
# Python programs and using Python modules.  To quit this help utility and
# return to the interpreter, just type "quit".
#
# To get a list of available modules, keywords, symbols, or topics, type
# "modules", "keywords", "symbols", or "topics".  Each module also comes
# with a one-line summary of what it does; to list the modules whose name
# or summary contain a given string such as "spam", type "modules spam".
#
# help> hot
# No Python documentation found for 'hot'.
# Use help() to get the interactive help utility.
# Use help(str) for help on the str class.
#
# help> not
# Boolean operations
# ******************
#
# ...    # a dalších 32 řádků výkladu
#
# help>
#
# You are now leaving help and returning to the Python interpreter.
# If you want to ask for help on a particular object directly from the
# interpreter, you can type "help(object)".  Executing "help('string')"
# has the same effect as typing a particular string at the help> prompt.
# >>>



#Výpis 4.3:	Volání funkce rozepsané na více řádcích
############################################################################
print("První argument ",
      "Druhý argument ",
      )
# První argument  Druhý argument
print( 1,        #První
       2,        #Druhý
     )
# 1 2



#Výpis 4.0: Popisek
############################################################################
dbg.stop_mod (0, __name__)
