#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/68_PYT/m06__Proměnné.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
6  Proměnné.

Co se v kapitole naučíte
Tato kapitola vás naučí používat proměnné. Probere základy správy paměti
a vysvětlí vám, jaká jsou v Pythonu pravidla pro tvorbu názvů.
Ukáže vám, jak proměnné zavést a inicializovat, a seznámí vás
se základními pravidly práce s proměnnými. V průběhu dalšího výkladu
ještě probere tzv. lambda výrazy a přiřazovací výraz.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
############################################################################



#Výpis 6.1:	Přiřazení hodnoty proměnné
############################################################################
a = 123
a
# 123
#!# a = a + x
# Traceback (most recent call last):
#   File "<pyshell#2>", line 1, in <module>
#     a = a + x
# NameError: name 'x' is not defined
x = "Žiju!"
x
# 'Žiju!'
a = 'Sto dvacet tři'
a
# 'Sto dvacet tři'
a = None     #Tím vlastně říkám, že v proměnné nic není
a            #Je li hodnotou proměnné None, intepret ji netiskne
# >>>



#Výpis 6.2:	Skrytá běhová chyba
############################################################################
n = 4
s = n * "Puf"
s
# 'PufPufPufPuf'
n = n / 2
#!# s = n * "Puf"
# Traceback (most recent call last):
#   File "<pyshell#6>", line 1, in <module>
#     s = n * "Puf"
# TypeError: can't multiply sequence by non-int of type 'float'
# >>>



#Výpis 6.3:	Současné přiřazení skupiny hodnot proměnným
############################################################################
a = 1;   b = 2
a
# 1
a, b
# (1, 2)
x = y = z = 123
x, y, z
# (123, 123, 123)
x, y, z = 10, 20, 30
x, y, z
# (10, 20, 30)
#!# a, b, c = 11, 22
# Traceback (most recent call last):
#   File "<pyshell#8>", line 1, in <module>
#     a, b, c = 11, 22
# ValueError: not enough values to unpack (expected 3, got 2)
#!# a, b, c = 11, 22, 33, 44
# Traceback (most recent call last):
#   File "<pyshell#10>", line 1, in <module>
#     a, b, c = 11, 22, 33, 44
# ValueError: too many values to unpack (expected 3)
#!# a, b, c
# Traceback (most recent call last):
#   File "<pyshell#11>", line 1, in <module>
#     a, b, c
# NameError: name 'c' is not defined
a, b
# (1, 2)
# >>>



#Výpis 6.4:	Zavedení proměnných inf a nan
############################################################################
inf = float('inf');   nan = float('nan')
inf*inf, -inf*inf, -123/inf, -123/-inf, nan
# (inf, -inf, -0.0, 0.0, nan)
type(inf), type(nan)
# (<class 'float'>, <class 'float'>)
# >>>



#Výpis 6.5:	Ukázky vnořeného volání funkcí
############################################################################
c = '€';   code = ord(c);   hexcode = hex(code)
print('VAR:  Kód znaku', c, "je", code, "=", hexcode)
# VAR:  Kód znaku € je 8364 = 0x20ac
print('CALL: Kód znaku', c, "je", ord(c), "=", hex(ord(c)))
# CALL: Kód znaku € je 8364 = 0x20ac
# >>>



#Výpis 6.6:	Zjištění typu objektu
############################################################################
v = 0           #Ukládám do proměnné celé číslo
type(v)         #Prověřuji obsah proměnné
# <class 'int'>
type(0.0)       #Prověřovaná hodnota je reálné (desetinné) číslo
# <class 'float'>
type(1j)        #Prověřovaná hodnota je komplexní číslo
# <class 'complex'>
type("Text")    #Prověřovaná hodnota je text
# <class 'str'>
v = True        #Prověřuji logickou hodnotu (viz příští kapitolu)
type(v)
# <class 'bool'>
type(None)      #Prověřuji hodnotu reprezentující nepřítomnost dat
# <class 'NoneType'>
type(int)       #Datový typ je hodnotou typu type
# <class 'type'>
type(type)      #Datový typ type je také hodnotou typu type
# <class 'type'>
# >>>



#Výpis 6.7:	Přiřazení funkcí (přesněji odkazů na funkce) do proměnných
############################################################################
f = min
type(f)
# <class 'builtin_function_or_method'>
f('První', 'Druhý', 'Třetí')
# 'Druhý'
f = max
f('První', 'Druhý', 'Třetí')
# 'Třetí'
type(f)
# <class 'builtin_function_or_method'>
f.__name__
# 'max'
# >>>



#Výpis 6.8:	Definice a použití lambda výrazu
############################################################################
f2c = lambda fahr: 5 * (fahr - 32) / 9
print('Papír hoří při', round(f2c(451)), '\N{DEGREE CELSIUS}')
# Papír hoří při 233 ℃
# >>>



#Výpis 6.9:	Přiřazovací výraz a jeho použití
############################################################################
cp = (co1 := 3*3) + (co2 := 4*4)
co1, co2, cp
# (9, 16, 25)
#!# pi := 3.1415926
# SyntaxError: invalid syntax
(pi := 3.1415926)
# 3.1415926
pi
# 3.1415926
# >>>



#Výpis 6.10:	Ovlivnění toho, bude li se zobrazovat systémový
#               či uživatelský podpis
############################################################################
f'{(s1:="string")=} × s2={(s2:="STRING")};   s1={s1} × {s2=}'
# '(s1:="string")=\'string\' × s2=STRING;   s1=string × s2=\'STRING\''
f'{(s1:="string")=!s} × s2={(s2:="STRING")!r};   s1={s1!r} × {s2=!s}'
# '(s1:="string")=string × s2=\'STRING\';   s1=\'string\' × s2=STRING'
# >>>



##### Kapitola 6.14  F-stringy – rozšiřující informace
############################################################################
f"""Součet je {123456789
             + 987654321}"""
'Součet je 1111111110'
# >>>

#---------------------------------------------------------------------------



#Výpis 6.0: Popisek
############################################################################
dbg.stop_mod (0, __name__)
