#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/68_PYT/m09__Moduly.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
9  Moduly

Co se v kapitole naučíte
Tato kapitola vám vysvětlí, co to jsou moduly,
jak do nich ukládat zdrojový kód a jak s nimi pracovat v programu.
Naučíte se importovat modul, s nímž potřebujete pracovat.
Zjistíte, jak v případě potřeby znovu načíst již importovaný modul
a hlavně jaké záludnosti na vás při reimportu modulu čekají.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
############################################################################



#Výpis 9.1:	Importování modulů
############################################################################
#!# turtle.Turtle()   # Před importem modulu jsou jeho atributy nepoužitelné
# Traceback (most recent call last):
#   File "<pyshell#1>", line 1, in <module>
#     turtle.Turtle()   # Před importem modulu jsou jeho atributy nepoužitelné
# NameError: name 'turtle' is not defined
import turtle
t = turtle.Turtle()
t.forward(50)
t.left(90); t.forward(50)
# >>>



#Výpis 9.2:	Přejmenování importovaného modulu
############################################################################
korytnačka = turtle          # Korytnačka = želva slovensky
tk = korytnačka.Turtle()     # Nová želva, kvalifikujeme názvem proměnné
tk.left(90); tk.forward(50)  # Želva nakreslila čáru směrem vzhůru
# >>>
import turtle as želva  # Nevytváří se nový objekt, použije se stávající
tz = želva.Turtle()          # Třetí želva
tz.forward(-100)             # Přesune se o 100 bodů vlevo
# >>>
turtle; korytnačka; želva    #Vypisují se podpisy odkazovaných objektů
# <module 'turtle' from 'C:\\_PGM\\Python3x\\lib\\turtle.py'>
# <module 'turtle' from 'C:\\_PGM\\Python3x\\lib\\turtle.py'>
# <module 'turtle' from 'C:\\_PGM\\Python3x\\lib\\turtle.py'>
(turtle is korytnačka) and (turtle is želva)  # Jsou objekty identické?
# True
# >>>



#Výpis 9.3:	Import zadaných objektů ze zadaného modulu
############################################################################
from math import sin, cos, pi as PI, tau as TAU    # τ = 2 * π
sin(PI/2), cos(PI), cos(TAU)
# (1.0, -1.0, 1.0)
#!# math
# Traceback (most recent call last):
#   File "<pyshell#2>", line 1, in <module>
#     math
# NameError: name 'math' is not defined
import math
math
# <module 'math' (built-in)>
math.tan(PI/4)
# 0.9999999999999999
# >>>



#Výpis 9.4:	Použitelnost proměnné s odkazem na modul
############################################################################
import math as m   # Do proměnné m se uloží odkaz na modul
m
# <module 'math' (built-in)>
m.tan(PI/4)        # Tuto proměnnou můžeme využít ke kvalifikaci
# 0.9999999999999999
#!# from m import tan  # Nemůžeme ji však využít pro další import
# Traceback (most recent call last):
#   File "<pyshell#5>", line 1, in <module>
#     from m import tan
# ModuleNotFoundError: No module named 'm'
#!# from 'math' import tan  # Nepomůže ani použití stringu s názvem modulu
# SyntaxError: invalid syntax
# >>>



#Výpis  9.5:	Import všech objektů ze zadaného modulu
############################################################################
#!# tan(PI/4)
# Traceback (most recent call last):
#   File "<pyshell#4>", line 1, in <module>
#     tan(PI/4)
# NameError: name 'tan' is not defined
from math import *
tan(PI/4)
# 0.9999999999999999
# >>>



#Výpis  9.6:	Demonstrace nárůstu počtu atributů po hromadném importu
############################################################################
# ============================ RESTART: Shell ============================
dir()    # Výchozí atributy modulu po restartu
# ['__annotations__', '__builtins__', '__doc__', '__loader__', '__name__', '__package__', '__spec__']
len(dir())
# 7
from math import *
len(dir())
# 65
# >>>



#Výpis 9.7:	Modul builtins
############################################################################
# ============================ RESTART: Shell ============================
f'{type(__builtins__)=}. {__builtins__.__name__=}'
# "type(__builtins__)=<class 'module'>. __builtins__.__name__='builtins'"
#!# builtins
# Traceback (most recent call last):
#   File "<pyshell#8>", line 1, in <module>
#     builtins
# NameError: name 'builtins' is not defined
import builtins
builtins is __builtins__
# True
# >>>



#Výpis 9.0: Popisek
############################################################################
dbg.stop_mod(0, __name__)
