#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/68_PYT/m09__Moduly.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
10  Vytvoření vlastního modulu

Co se v kapitole naučíte
Tato kapitola vás naučí vytvořit vlastní modul.
Ukáže, jak zveřejňovat průběh importu při hledání chyb
a jak v případě potřeby načíst opravený importovaný modul a hlavně
jaké záludnosti na vás při reimportu modulu čekají.
Na závěr vás ještě stručně seznámí s problematikou cyklického importu.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
############################################################################



#Výpis 10.1:	Modul m10a_Modul sloužící k demonstraci chování Pythonu
#               při zavádění modulu
############################################################################


""" Je uloženo v souboru 
p:\68_PYT\m10a_Modul.py
"""



#Výpis 10.2:	Import modulu m10a_Modul
############################################################################
# ============================ RESTART: Shell ============================
import m10a_Modul as m
# ===== Modul m10a_Modul ===== START
# Hodnoty výrazových příkazů se nezobrazují
# Chcete-li zobrazit nějakou hodnotu, musíte ji explicitně vytisknout
#    První verze 123456 Stále první verze
# ===== Modul m10a_Modul ===== STOP
m.text, m.num, m.txt2, m._np
# ('První verze', 123456, 'Stále první verze', 'Neveřejné')
help(m)
# Help on module m10a_Modul:
#
# NAME
#     m10a_Modul
#
# DESCRIPTION
#     Úvodní modul demonstrující základní pravidla pro tvorbu modulů,
#     jejich zavádění a následnou práci s nimi.
#     Modul se omezuje na definici proměnných a provedení několika příkazů.
#
# DATA
#     num = 123456
#     text = 'První verze'
#     txt2 = 'Stále první verze'
#
# FILE
#     p:\68_pyt\m10a_modul.py
#
#
m
# <module 'm10a_Modul' from 'P:\\68_PYT\\m10a_Modul.py'>
#!# m10a_Modul
# Traceback (most recent call last):
#   File "<pyshell#4>", line 1, in <module>
#     m10a_Modul
# NameError: name 'm10a_Modul' is not defined
import m10a_Modul
m10a_Modul
# <module 'm10a_Modul' from 'P:\\68_PYT\\m10a_Modul.py'>
dir()
# ['__annotations__', '__builtins__', '__doc__', '__loader__', '__name__', '__package__', '__spec__', 'm', 'm10a_Modul']
# >>>



#Výpis 10.3:	Nové načtení modulu m10a_Modul
############################################################################
from m10a_Modul import *;   text, num, txt2;   m.text, m.num, m.txt2
# ('První verze', 123456, 'Stále první verze')
# ('První verze', 123456, 'Stále první verze')
from importlib import reload
mm = reload(m)
# ===== Modul m10a_Modul ===== START
# Hodnoty výrazových příkazů se nezobrazují
# Chcete-li zobrazit nějakou hodnotu, musíte ji explicitně vytisknout
#    Druhá verze 23456 Stále druhá verze
# ===== Modul m10a_Modul ===== STOP
print(f'{mm=}, {(m is mm)=}')
# mm=<module 'm10a_Modul' from 'P:\\68_PYT\\m10a_Modul.py'>, (m is mm)=True
# >>>



#Výpis 10.4:	„Neaktualizace“ přímo importovaných odkazů
############################################################################
text, num, txt2;   m.text, m.num, m.txt2
# ('První verze', 123456, 'Stále první verze')
# ('Druhá verze', 23456, 'Stále druhá verze')
from m10a_Modul import *;   text, num, txt2;   m.text, m.num, m.txt2
# ('Druhá verze', 23456, 'Stále druhá verze')
# ('Druhá verze', 23456, 'Stále druhá verze')
# >>>



#Výpis 10.5:	Opětné načtení verze s chybou
############################################################################
reload(m)
# ===== Modul m10a_Modul ===== START
# Původní hodnoty: Druhá verze 23456 Stále druhá verze
# Traceback (most recent call last):
#   File "<pyshell#24>", line 1, in <module>
#     reload(m)
#   File "C:\_PGM\Python\Python310\lib\importlib\__init__.py", line 169, in reload
#     _bootstrap._exec(spec, module)
#   File "<frozen importlib._bootstrap>", line 619, in _exec
#   File "<frozen importlib._bootstrap_external>", line 835, in exec_module
#   File "<frozen importlib._bootstrap>", line 241, in _call_with_frames_removed
#   File "P:\68_PYT\m10a_Modul.py", line 16, in <module>
#     num  = 3_456 / 0
# ZeroDivisionError: division by zero
m.text, m.num, m.txt2
# ('Třetí verze', 23456, 'Stále druhá verze')
# >>>



#Výpis 10.6:	Import modulu posixpath nebo ntpath zprostředkovaný modulem os
############################################################################
import sys   #$ SYNC ???
_names = sys.builtin_module_names   # Názvy všech přeložených modulů

if 'posix' in _names:   # Modul posix je definován v Unix-like systémech
    import posixpath as path
elif 'nt' in _names:    # Modul nt je definován pro Windows
    import ntpath as path
else:
    raise ImportError('no os specific module found')



#Výpis 10.7:	Definice modulu m10b_Demo_all vyjmenovávajícího veřejné atributy
############################################################################

""" Je uloženo v souboru 
m10b_Demo_all.py
"""



#Výpis 10.8:	Hvězdičkový import modulu m10b_Demo_all
############################################################################
from dbg import prDict
prDict()
# ##### Atributy objektu: <module '__main__' (built-in)>
# prDict = <function prDict at 0x0000017F33086F80>
from m10b_Demo_all import *
# ===== Modul m10b_Demo_all ===== START
# ===== Modul m10b_Demo_all ===== STOP
prDict()
# ##### Atributy objektu: <module '__main__' (built-in)>
# prDict = <function prDict at 0x0000017F33086F80>
# v1 = Veřejný
# v2 = Také veřejný
# v3 = Ještě jeden veřejný
import m10b_Demo_all as m10
prDict(m10)
# ##### Atributy objektu: <module 'm10b_Demo_all' from 'P:\\68_PYT\\m10b_Demo_all.py'>
# dbg = <module 'dbg' from 'P:\\68_PYT\\dbg.py'>
# v1 = Veřejný
# v2 = Také veřejný
# s1 = Skrytý
# s2 = Také skrytý
# v3 = Ještě jeden veřejný
# >>>


#Výpis 10.7:	Prověrka zprostředkování importu
############################################################################
import os
os.path;   os.path.join
# <module 'ntpath' from 'C:\\_PGM\\Python\\Python310\\lib\\ntpath.py'>
# <function join at 0x0000024E466CFA60>
# >>>



#Výpis 10.8:	Modul m10c_Circular_C importující modul m10d_Circular_D
############################################################################

""" Je uloženo v souboru 
m10c_Circular_C.py
"""



#Výpis 10.9:	Modul m10d_Circular_D importující modul m10c_Circular_C
############################################################################

""" Je uloženo v souboru 
m10d_Circular_D.py
"""



#Výpis 10.0: Popisek
############################################################################
dbg.stop_mod(0, __name__)
