#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/68_PYT/m10__Definice_funkcí.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
11  Definice funkcí

Co se v kapitole naučíte
Tato kapitola vám nejprve vysvětlí, jak definovat jednoduché funkce,
probere význam a použití parametrů a argumentů včetně možnosti zadání
jejich implicitních hodnot. Naučí vás definovat funkce vracející hodnotu
a upozorní ne nebezpečí funkcí s vedlejším efektem.
Ukáže vám, jak se dají argumenty funkce a její návratové hodnoty anotovat,
a předvede jak definovat funkce v samostatném modulu.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
############################################################################



#Výpis 11.1: Jednořádková definice funkce
############################################################################
f = "Zatím nic";   f
# 'Zatím nic'
def f(): 'Nedoporučovaný zápis'; print('Jednořádková definice funkce')

f
# <function f at 0x000001AED2FB1310>
f()             #SYNC
# Jednořádková definice funkce
help(f)
# Help on function f in module __main__:
#
# f()          #SYNC #SYNC
#     Nedoporučovaný zápis
#
# >>>



#Výpis 11.2:	Víceřádková definice funkce
############################################################################
def f():
    """Funkce definovaná doporučovaným způsobem."""
    print('Funkce definovaná na více řádcích:', f)
    print('Všechny příkazy těla musejí být shodně odsazeny')


f()
# Funkce definovaná na více řádcích: <function f at 0x000001AED2FA2160>
# Všechny příkazy těla musejí být shodně odsazeny
f = 'Teď je tu opět text'; f
# 'Teď je tu opět text'
f()
# Traceback (most recent call last):
#   File "<pyshell#85>", line 1, in <module>
#     f()
# TypeError: 'str' object is not callable
# >>>



#Výpis 11.3:	Přisazení definice funkce v interaktivním režimu
############################################################################
def stringy():
    """Různé způsoby zápisu víceřádkových stringů.
    """
    txt1 = '''Používám-li v programu víceřádkové stringy,
musíme počítat s tím, že začínají u levého okraje,                  #SYNC
takže buď ruší celkový vzhled funkce,                               #SYNC
           anebo do výsledného testu zanášejí svá zarovnávací       #SYNC
           odsazení, která většinou působí rušivě.\n'''
    txt2 = "Nechceme-li proto používat víceřádkový string,\n" \
           "musíme string rozdělit na části - nejlépe řádky,\n" \
           "každý takový řádek ukončit znakem konce řádku a přidat\n" \
           "za něj přidat zpětné lomítko, jak je to předvedeno zde.\n"
    txt3 = ('Druhou možností je výše zmíněný soubor jednořádkových\n'
            'stringů uzavřít do závorek. V obou případech využijeme\n'
            'toho, že za sebou následující stringové literály\n'
            'Python automaticky sloučí do jednoho stringu.')
    print(txt1, txt2, txt3, sep='   ')

stringy()
# Používám-li v programu víceřádkové stringy,
# musíme počítat s tím, že začínají u levého okraje,
# takže buď ruší celkový vzhled funkce,
#            anebo do výsledného testu zanášejí svá zarovnávací
#            odsazení, která většinou působí rušivě.
#    Nechceme-li proto používat víceřádkový string,
# musíme string rozdělit na části - nejlépe řádky,
# každý takový řádek ukončit znakem konce řádku a přidat
# za něj přidat zpětné lomítko, jak je to předvedeno zde.
#    Druhou možností je výše zmíněný soubor jednořádkových
# stringů uzavřít do závorek. V obou případech využijeme
# toho, že za sebou následující stringové literály
# Python automaticky sloučí do jednoho stringu.
# >>>



#Výpis Výpis 11.4:	Modul m11a_Funkce_v_modulu demonstrující pravidla
#                   pro definice funkcí v modulu
############################################################################

""" Je uloženo v souboru 
m11a_Funkce_v_modulu.py 
"""



#Výpis 11.5:	Dynamická povaha jazyka při definici a volání funkcí
############################################################################
#!# varX
# Traceback (most recent call last):
#   File "<pyshell#23>", line 1, in <module>
#     varX
# NameError: name 'varX' is not defined
def fceX():
    """V definici funkce lze použít i dosud neexistující proměnnou.
    Důležité je, aby existovala v době, kdy bude funkce zavolána.
    """
    print(f'Proměnná {varX = }')

varX = 'Žiju'   # Proměnná právě vznikla
fceX()          # Při volání funkce překladač zjistí, že proměnná existuje
# Proměnná varX = Žiju
varX = 'Končím'
fceX()          # Mezi voláními proměnná změnila hodnotu
# Proměnná varX = Končím
del varX        # Proměnná byla odstraněna
fceX()          # Nyní skončí volání funkce chybou
# Traceback (most recent call last):
#   File "<pyshell#30>", line 1, in <module>
#     fceX()          # Nyní skončí volání funkce chybou
#   File "<pyshell#24>", line 5, in fceX
#     print('Proměnná varX =', varX)
# NameError: name 'varX' is not defined
#!# def fceX(): "Funkce se syntaktickou chybou"; a=01
# SyntaxError: leading zeros in decimal integer literals are not permitted; use an 0o prefix for octal integers
varX = 'Zmrtvýchvstání'; fceX()
# Proměnná varX = Zmrtvýchvstání
# >>>



#Výpis 11.6:	Definice modulu m11b_dbg_demo
############################################################################

""" Je uloženo v souboru 
m11b_dbg_demo.py 
"""



#Výpis 11.7:	Import modulu m11b_dbg_demo a zavolání jeho funkce fce1()
############################################################################
import m11b_dbg_demo as m
# ===== Modul m11b_dbg_demo ===== START
# ===== Modul m11b_dbg_demo ===== STOP
m.fce1()
# ==> fce1 - Funkce volaná ve vrchní hladině
# |   ==> fce2 - Střední hladina: i=1
# |   |   ==> fce3 - Spodní hladina: k=1
# |   |   |   Nějaké tisky pro funkci fce3()
# |   |   |   Několikařádkový Kontrolní tisk
# |   |   |   Druhý řádek
# |   |   |   Třetí řádek
# |   |   <== fce3
# |   <== fce2 - Vrací: 1
# |   ==> fce2 - Střední hladina: i=2
# |   |   ==> fce3 - Spodní hladina: k=4
# |   |   |   Nějaké tisky pro funkci fce3()
# |   |   |   Několikařádkový Kontrolní tisk
# |   |   |   Druhý řádek
# |   |   |   Třetí řádek
# |   |   <== fce3
# |   <== fce2 - Vrací: 16
# <== fce1
# >>>



#Výpis 11.0:	Popisek
############################################################################
dbg.stop_mod (0, __name__)
