#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/68_PYT/m13__Pokročilé_rysy_funkcí.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
13  Pokročilé rysy funkcí

Co se v kapitole naučíte
Tato kapitola je věnována pokročilým vlastnostem funkcí
a možnostem jejich použití.
Je určena pro programátory s alespoň základními zkušenostmi.
Naprostí začátečníci ji mohou přeskočit. Umístil jsem ji sem proto,
abyste měli související informace pohromadě, a využil jsem toho,
že k probrání těchto rysů není následně probíraná látka potřeba.

Kapitola vás postupně seznámí s problematikou jmenných prostorů
a lokality používaných proměnných, pohovoří o možnosti
definovat funkci uvnitř funkce, o funkcích vyšších řádů,
které mají za parametr funkci (nebo samy vracejí funkci),
a o některých dalších vlastnostech.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
############################################################################



#Výpis 13.1:	Definice vnitřních funkcí
############################################################################
def vnější():
    print('Volána funkce vnější')
    def vnitřní1():
        print('  Volána funkce vnitřní1')
        def vnitřní2(): print('    Volána funkce vnitřní2')
        vnitřní2()
        print('  Funkce vnitřní1 končí')
    print('Budu volat vnitřní1')
    vnitřní1()
    print('Funkce vnější končí')

vnější()
# Volána funkce vnější
# Budu volat vnitřní1
#   Volána funkce vnitřní1
#     Volána funkce vnitřní2
#   Funkce vnitřní1 končí
# Funkce vnější končí
# >>>



#Výpis 13.2: Zakrytí globální proměnné stejnojmennou lokální
############################################################################
glo = 'globální'    # SYNC
def fce1(): print(f'{glo = }')
                                                                    #SYNC
fce1()
# glo = 'globální'
def fce2(): glo = 'lokální'; print(f'{glo = }')
                                                                    #SYNC
fce2()
# glo = 'lokální'
print(f'{glo = }')
# glo = 'globální'
#!# def fce3(): print(glo); glo  = 'lokální'
                                                                    #SYNC
#!# fce3()
# Traceback (most recent call last):
#  File "<pyshell#28>", line 1, in <module>
#    fce3()
#  File "<pyshell#27>", line 1, in fce3
#    def fce3(): print(glo); glo  = 'lokální'
# UnboundLocalError: local variable 'glo' referenced before assignment
# >>>



#Výpis 13.3: Použití příkazu global
############################################################################
var1 = var2 = 'globální'
#!# var3
# Traceback (most recent call last):
#  File "<pyshell#31>", line 1, in <module>
#    var3
# NameError: name 'var3' is not defined
def fceg():
    """Demonstrace korektní modifikace globálních proměnných funkcí."""
    global var1, var3
    var1 = var2 = 'lokální'
    var3 = 'Definovaná'
    print(f'Uvnitř: {var1=}, {var2=},  {var3=}')

fceg();  print(f'Vně:    {var1=}, {var2=}, {var3=}')
# Uvnitř: var1='lokální', var2='lokální', var3='Definovaná'
# Vně:    var1='lokální', var2='globální', var3='Definovaná'
# >>>



#Výpis 13.4: Použití příkazu nonlocal
############################################################################
def f1():
    """První úroveň - vnější funkce."""
    def f2():
        """Druhá úroveň - vnitřní funkce."""
        def f3():
            """Třetí úroveň - vnitřní funkce ve vnitřní funkci"""
            nonlocal v13, v23
            v13 += ' v třetí'
            v23 += ' v třetí'
            nonlocal v31, v32
            v31 =  'Třetí pro první'
            v32  = 'Třetí pro druhou'
            print(f'Ve třetí: {v11=}, {v12=}, {v13=}\n'
                  f'          {v23=}, {v31=}, {v32=}')
        nonlocal v12
        v23  = 'Druhá'  # Musíme definovat proměnné, které bude
        v32  = None     # vnitřní funkce deklarovat jako nonlocal
        v12 += ' v druhé'
        f3()
        print(f'Ve druhé: {v11=}, {v12=}, {v13=}\n'
              f'          {v23=}, {v31=}, {v32=}')
    v11 = v12 = v13 = 'První'   # Zde definujeme všechny, aby byly
    v23 = v31 = v32 = None      # viditelné a použitelné v příkazu tisku
    f2()
    print(f'V  první: {v11=}, {v12=}, {v13=}\n'
          f'          {v23=}, {v31=}, {v32=}')

f1()
# Ve třetí: v11='První', v12='První v druhé', v13='První v třetí'
#           v23='Druhá v třetí', v31='Třetí pro první', v32='Třetí pro druhou'
# Ve druhé: v11='První', v12='První v druhé', v13='První v třetí'
#           v23='Druhá v třetí', v31='Třetí pro první', v32='Třetí pro druhou'
# V  první: v11='První', v12='První v druhé', v13='První v třetí'
#           v23=None, v31='Třetí pro první', v32=None
# >>>



#Výpis 13.5: Demonstrace vnořeného volání funkcí
############################################################################
def kulaté(arg):
    """Vrátí argument zabalený do kulatých závorek."""
    print(f'==> Volána funkce kulaté({arg!r})')
    ret = '(' + arg + ')'
    print(f'<== Funkce kulaté() vrací: {ret!r}')
    return ret

def hranaté(arg):
    """Vrátí argument zabalený do hranatých závorek."""
    print(f'==> Volána funkce hranaté({arg!r})')
    ret = '[' + arg + ']'
    print(f'<== Funkce hranaté() vrací: {ret!r}')
    return ret

def lomené(arg):
    """Vrátí argument zabalený do lomených závorek."""
    print(f'==> Volána funkce lomené({arg!r})')
    ret = '<' + arg + '>'
    print(f'<== Funkce lomené() vrací: {ret!r}')
    return ret

print(f'Nejdříve {hranaté(lomené(kulaté("text")))} '
      f'pak {lomené("potom")}')
# ==> Volána funkce kulaté('text')
# <== Funkce kulaté() vrací: '(text)'
# ==> Volána funkce lomené('(text)')
# <== Funkce lomené() vrací: '<(text)>'
# ==> Volána funkce hranaté('<(text)>')
# <== Funkce hranaté() vrací: '[<(text)>]'
# ==> Volána funkce lomené('potom')
# <== Funkce lomené() vrací: '<potom>'
# Nejdříve [<(text)>] pak <potom>
# >>>



#Výpis 13.6: Použití funkce vracející funkci
############################################################################
def actionF(operator):
    """Vrátí funkci realizující operaci zadanou argumentem."""
    def ADD(x, y):  # Sloučí podpisy argumentů
        result = str(x) + str(y)
        return result
    def MUL(n, s):  # Vrátí opakovací řetězec
        result = int(n) * str(s)
        return result
    def ERR(x, y):  # Vrátí chybovou zprávu
        return '### NEZNÁMÁ AKCE: «' + str(operator) + '» ###'
    return ADD if operator == '+'  else \
           MUL if operator == '*'  else \
           ERR

def actionL(operator):
    """Vrátí funkci realizující operaci zadanou argumentem."""
    return (lambda x, y: str(x) + str(y)) if operator == '+' \
      else (lambda a, b: int(a) * str(b)) if operator == '*' \
      else (lambda x, y: '### NEZNÁMÁ AKCE: «' + str(operator) + '» ###')

actionF('+')(1, 2)
# '12'
fx = actionL('*');  fx(3, 4)
# '444'
actionL(...)(5, 6)
# '### NEZNÁMÁ AKCE: «Ellipsis» ###'
# >>>



#Výpis 13.7: Použití atributů funkce
############################################################################
def countingFunction():
    countingFunction.count += 1
    print('Byla jsem zavolána', countingFunction.count, 'krát')

countingFunction.count = 0
countingFunction(); countingFunction(); countingFunction()
# Byla jsem zavolána 1 krát
# Byla jsem zavolána 2 krát
# Byla jsem zavolána 3 krát
# >>>



#Výpis 13.8: Nelokální proměnné a uzávěry
############################################################################
def genf(id):
    count = 0
    def g():
        nonlocal count
        count += 1
        return id + '_' + str(count)
    return g

ga = genf('A');   gb = genf('B')
ga(), ga(), gb(), ga(), gb()
# ('A_1', 'A_2', 'B_1', 'A_3', 'B_2')
# >>>



#Výpis 13.9:	Definice modulu m13b_Circular_B importujícího modul
#               m13c_Circular_C
############################################################################

""" Je uloženo v souboru 
m13b_Circular_B 
"""



#Výpis 13.10:	Definice modulu m13c_Circular_C importujícího modul
#               m13b_Circular_B
############################################################################

""" Je uloženo v souboru 
m13c_Circular_C 
"""



#Výpis 13.11:	Import modulu m13b_Circular_B
############################################################################
import m13b_Circular_B
# ===== Modul m13b_Circular_B ===== START
# ===== Modul m13c_Circular_C ===== START
# ===== Modul m13c_Circular_C ===== STOP
# Modul B: mc.c1 = 'Modul C před importem modulu B'
# Modul B: mc.c2 = 'Modul C stále před importem modulu B'
# Modul C: jdu importovat modul B
# Modul C: po importu modulu B
# Modul C: mb.b1 = 'Modul B před importem modulu C'
# Modul C: mb.b2 = 'Modul B za importem modulu C'
# ===== Modul m13b_Circular_B ===== STOP
# >>>



#Výpis 13.0: Popisek
############################################################################
dbg.stop_mod (0, __name__)
