#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/68_PYT/m15__Opakování.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
15  Opakování.

Co se v kapitole naučíte
Tato kapitola probere konstrukce vedoucí k opakovanému provádění částí kódu.
Nejprve předvede možnosti rekurzivního volání, a poté se zaměří na cykly.
Pak vám představí nejprve cyklus while, u nějž o pokračování rozhoduje
splnění nějaké podmínky, a po něm cyklus for používaný při postupném
zpracovávání dat dodávaných nějakým zdrojem.
Nejprve ukáže možnost vyjmenování zpracovávaných hodnot, poté předvede,
jak použít jako zdroj funkci range() či string. Nezapomene ani na vnořování
cyklů a na možnost využití větve else.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
############################################################################



#Výpis 15.1: Ukázky definic funkcí používajících rekurzivní volání
############################################################################
def recDemo(n, s=''):
    """Demonstrace rekurzivního volání."""
    print(s, '==>', n)          # Funkce ohlašuje svůj start
    if n > 0:       # Toto není poslední vnoření
        recDemo(n-1, s+'  ')    # Další hlášení bude posunuté o dvě mezery
    print(s, n , '<==')         # Funkce ohlašuje svoje ukončení

recDemo(5)
#  ==> 5
#    ==> 4
#      ==> 3
#        ==> 2
#          ==> 1
#            ==> 0
#            0 <==
#          1 <==
#        2 <==
#      3 <==
#    4 <==
#  5 <==
def r():    # Demonstrace neukončeného rekurzivního volání
    r()     # Neexistence ukončovací podmínky vede k nekonečné rekurzi  #SYNC

r()   # Nekonečná rekurze vede k přetečení zásobníku
# Traceback (most recent call last):
#   File "<pyshell#3>", line 1, in <module>
#     r()   # Nekonečná rekurze vede k přetečení zásobníku
#   File "<pyshell#2>", line 2, in r
#     r()     # Neexistence ukončovací podmínky vede k nekonečné rekurzi
#   File "<pyshell#2>", line 2, in r
#     r()     # Neexistence ukončovací podmínky vede k nekonečné rekurzi
#   File "<pyshell#2>", line 2, in r
#     r()     # Neexistence ukončovací podmínky vede k nekonečné rekurzi
#   [Previous line repeated 1022 more times]
# RecursionError: maximum recursion depth exceeded
# >>>



#Výpis 15.2:	Rekurzivní definice faktoriálu
############################################################################
def factR(n:int) -> None:
    """Rekurzivní definice faktoriálu."""
    if n<=1 : return 1
    return n * factR(n-1)

factR(5)
#120
factR(99)    # Python umožňuje spočítat i faktoriál velkých čísel
#933262154439441526816992388562667004907159682643816214685929638952175999932299156089414639761565182862536979208272237582511852109168640000000000000000000000
#>>>



#Výpis 15.3:	Ukázky definic funkcí používajících cyklus while
############################################################################
def countDown(n:int) -> None:
    """Odpočítává od zadaného argumentu dolů a místo nuly vytiskne  BUM."""
    while n>0:
        print(n, end='-')
        n -= 1
    print('BUM')

countDown(5)
# 5-4-3-2-1-BUM
def factW(n:int) -> int:
    """Faktoriál počítaný pomocí cyklu while."""
    f = 1      # Hodnota vracená v případě, když n <= 1
    while n > 1:
        f *= n
        n -= 1
    return f

factW(5)
# 120
# >>>



#Výpis 15.4:	Nekonečný cyklus
############################################################################
def infinite():
    """Spustí prázdný nekonečný cyklus, který bude nutné přerušit zvenku."""
    while ...: pass    # Opakovaně se nedělá nic                      #SYNC
    print('Hotovo')    # Sem program nemá šanci dojít

infinite ()
# Traceback (most recent call last):
#   File "<pyshell#11>", line 1, in <module>
#     infinite ()
#   File "<pyshell#10>", line 3, in infinite
#     while ...: pass    # Opakovaně se nedělá nic
# KeyboardInterrupt
# >>>



#Výpis 15.5:	Použití příkazu break
############################################################################
def cumul(time: int,       # Kolik období se bude úročit
          interest: float, # Velikost úroku
         ) -> float:       # Akumulovaný násobek základní částky
    """Spočte násobek zadané částky pro zadaný počet úrokových období."""
    multiplier = 1 + interest/100
    sum = 1.    # Základní částka
    n   = 1     # Pořadové číslo období
    print("Průběžné násobky základní částky: 1,000", end='')
    while ...:
        sum *= multiplier
        if n >= time : break    #---------->
        print(' - ', n, ':', round(sum,3), sep='', end='')
        n += 1
    print('\nPo ', time, ' obdobích se při úroku ', interest, ' % naspoří ',
          round(sum,3), '-násobek základní částky.', sep='')

cumul(5,5)
# Průběžné násobky základní částky: 1,000 - 1:1.05 - 2:1.103 - 3:1.158 - 4:1.216
# Po 5 obdobích se při úroku 5 % naspoří 1.276-násobek základní částky.
# >>>



#Výpis 15.6:	Použití přiřazovacího výrazu v hlavičce cyklu while
############################################################################
seznam = 'Účastníci: '
while ((osoba:=input('Jméno: ')) != ''):
    seznam += osoba + ', '
    print(seznam)

# Jméno: Franta
# Účastníci: Franta,
# Jméno: Pepa
# Účastníci: Franta, Pepa,
# Jméno: Alena
# Účastníci: Franta, Pepa, Alena,
# Jméno:
while ...:
    osoba = input('Jméno: ')
    if not osoba: break
    seznam += osoba + ', '
    print(seznam)

# Jméno: Kazimír
# Účastníci: Franta, Pepa, Alena, Kazimír,
# Jméno:
# >>>



#Výpis 15.7:	Cyklus while využívající větev else
############################################################################
def isPrime(n: int) -> None:
    """Vypíše, zda je zadaný argument prvočíslem."""
    d = int(n**(1/2))   # Dělitel může být nejvýše odmocninou
    while d > 1:
        if n % d == 0:  # Zbytek po dělení
            print(n, 'je dělitelné číslem', d, end=' # ')
            break       # Větev else se přeskakuje
        d -= 1
    else: # Standardní konec:
        print(n, 'je prvočíslo', end=' ! ')
    print('KONEC TESTU')

isPrime(35); isPrime(37)
# 35 je dělitelné číslem 5 # KONEC TESTU
# 37 je prvočíslo ! KONEC TESTU
# >>>



#Výpis 15.8:	Použití příkazu continue
############################################################################
def sum3xC(x:int,   # Číslo, jehož následníci se mají sčítat
           n:int    # Počet sčítaných následníků nedělitelných třemi
    ) -> None:
    """Sečte zadaný počet čísel nedělitelných třemi následujících
       za zadaným číslem."""
    s = 0
    while n > 0:
        x += 1
        if x % 3 == 0:
            print(f'{x}ne', end=' ')
            continue
        s += x
        print(f'+ {x}', end=' ')
        n -= 1
    print("=", s)

sum3xC(7, 7)
# + 8 9ne + 10 + 11 12ne + 13 + 14 15ne + 16 + 17 = 89
def sum3xE(x:int,   # Číslo, jehož následníci se mají sčítat
           n:int    # Počet sčítaných následníků nedělitelných třemi
    ) -> None:
    """Sečte zadaný počet čísel nedělitelných třemi následujících
       za zadaným číslem."""
    s = 0
    while n > 0:
        x += 1
        if x % 3 == 0:
            print(f'{x}ne', end=' ')
        else:
          s += x
          print(f'+ {x}', end=' ')
          n -= 1
    print("=", s)

sum3xE(5, 5)
# 6ne + 7 + 8 9ne + 10 + 11 12ne + 13 = 49
# >>>



#Výpis 15.9:	Použití příkazu for se zdrojem definovaným jako sada hodnot
############################################################################
for val in (i:=1), 2+3j, 'čtyři', print, f'{5**3=}':
    print(f'{i}. položka = {val!r}')
    i += 1

# 1. položka = 1
# 2. položka = (2+3j)
# 3. položka = 'čtyři'
# 4. položka = <built-in function print>
# 5. položka = '5**3=125'
# >>>



#Výpis 15.10:	Použití příkazu for se zdrojem generovaným funkcí range()
############################################################################
for x in range(3*(step:=12), 99, step):
    print(f'{x}-{x*x}', end=', ')

# 36-1296, 48-2304, 60-3600, 72-5184, 84-7056, 96-9216,
step = 12
for x in range(3*step, 99, step):
    print(f'{x}-{x*x}', end=', ')

# 36-1296, 48-2304, 60-3600, 72-5184, 84-7056, 96-9216,
# >>>



#Výpis 15.11:	Indexace znaků v textovém řetězci – stringu
############################################################################
def indexing(s:str) -> None:
    n = len(s)
    print('Text: "' + s + '", znaků=' + str(n))
    for i in range(n):
        print(f' {i}:{s[i]}  ', end='')
    print()
    for i in range(-1, -n-1, -1):
        print(f'{i}:{s[i]}  ', end='')

indexing('Python')
# Text: "Python", znaků=6
#  0:P   1:y   2:t   3:h   4:o   5:n
# -1:n  -2:o  -3:h  -4:t  -5:y  -6:P
# >>>



#Výpis 15.12:	Zpracování jednotlivých znaků v textovém řetězci bez použití indexů
############################################################################
for c in "Dobrý den":
    print(f'({c}) ', end='')

# (D) (o) (b) (r) (ý) ( ) (d) (e) (n)
# >>>



#Výpis 15.13:	Ukázka zanořování cyklů
############################################################################
def seq_in_radix(radix:int) -> None:
    """Vypíše posloupnost 3ciferných hodnot v zadané číselné soustavě."""
    for c2 in range(radix):
        for c1 in range(radix):
            for c0 in range(radix):
                s = f'{c2}{c1}{c0}'
                print(s, end=', ')

seq_in_radix(2)
# 000, 001, 010, 011, 100, 101, 110, 111,
seq_in_radix(3)
# 000, 001, 002, 010, 011, 012, 020, 021, 022, 100, 101, 102, 110, 111, 112, 120, 121, 122, 200, 201, 202, 210, 211, 212, 220, 221, 222,
# >>>



#Výpis 15.14:	Příkaz for s postupným použitím více zdrojů
############################################################################
for x in range(1, 5), range(11, 15): print(x, end=', ')

# range(1, 5), range(11, 15),
for x in range(1, 5),: print(x, end=', ')

# range(1, 5),
for source in range(1, 5), range(11, 15):
    for x in source: print(x, end=', ')

# 1, 2, 3, 4, 11, 12, 13, 14,
# >>>



#Výpis 15.15:	Příkaz for s větví else
############################################################################
def for_else(start:int, step:int) -> None:
    """Vypíše prvních pět členů aritmetické řady se zadaným startem
    a krokem; objeví-li se však třináctka, výpis ukončí.
    """
    for n in range(start, start+5*step, step):
        if n == 13: break
        print(n, end='-')
    else:
        print('Povedlo se')
        return
    print('Zakopli jsme o třináctku')

for_else(0, 5)
# 0-5-10-15-20-Povedlo se
for_else(9, 2)
# 9-11-Zakopli jsme o třináctku
# >>>



#Výpis 15.Y:	Popisek
############################################################################
dbg.stop_mod (0, __name__)
