#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/68_PYT/m16__Ošetřování_chyb.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
16  Ošetřování chyb.

Co se v kapitole naučíte
Tato kapitola vám vysvětli princip reakce na běhové chyby prostřednictvím
vyvolávání, resp. vyhazování výjimek a jejich následného zachytávání.
Probere složený příkaz try s jeho větvemi except, else a finally.
Poté vysvětlí, jak výjimku vytvořit a následně vyhodit.
Na závěr ještě jednou probere příkaz assert.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
############################################################################



#Výpis 16.1:	Ukázky syntaktických chyb a reakcí na ně při zadávání příkazů
#               v prostředí IDLE
############################################################################
#!# text = "První" +   # Předčasné ukončení řádku
# SyntaxError: invalid syntax
#!# help(not)   # Nekorektní použití operátoru not
# SyntaxError: invalid syntax
#!# while True print('Hello world')   # Chybějící dvojtečka za hlavičkou cyklu
# SyntaxError: expected ':'
#!# "Neukončený text
# SyntaxError: unterminated string literal (detected at line 1)
#!# 0123   #Špatně zapsané číslo - počáteční nula je zakázaná
# SyntaxError: leading zeros in decimal integer literals are not permitted; use an 0o prefix for octal integers
# >>>



#Výpis 16.2:	Ukázky syntaktických chyb a reakcí na ně při zadávání
#               příkazů z konzolového okna
############################################################################
# Microsoft Windows [Version 10.0.19041.928]
# (c) Microsoft Corporation. Všechna práva vyhrazena.
#                                                                     #SYNC
# P:\68_PYT>C:\_PGM\Python\Python310\python
# Python 3.10.0a7 (tags/v3.10.0a7:53e5529, Apr  6 2021, 10:20:47) [MSC v.1928 64 bit (AMD64)] on win32
# Type "help", "copyright", "credits" or "license" for more information.
#!# def err_demo():
#!#     """Funkce obsahující syntaktickou chybu."""
#!#     while True print('Hello world')
#   File "<stdin>", line 3
#     while True print('Hello world')
#                ^
# SyntaxError: expected ':'
import m16a_Chyby
# Traceback (most recent call last):
#   File "<stdin>", line 1, in <module>
#   File "P:\68_PYT\m16a_Chyby.py", line 10
#     text = "První" +   # Předčasné ukončení řádku
#                        ^
# SyntaxError: invalid syntax
# >>>



#Výpis 16.3:	Zopakovaný výpis 10.5 ze strany 158 zobrazující načtení
#               třetí verze modulu m10a_Modul z výpisu 10.1 na straně 148
############################################################################
import m10a_Modul as m              # SYNC
from importlib import reload        # SYNC
reload(m)
# ===== Modul m10a_Modul ===== START
# Původní hodnoty: Druhá verze 23456 Stále druhá verze
# Traceback (most recent call last):
#   File "<pyshell#24>", line 1, in <module>
#     reload(m)
#   File "C:\_PGM\Python\Python310\lib\importlib\__init__.py", line 169, in reload
#     _bootstrap._exec(spec, module)
#   File "<frozen importlib._bootstrap>", line 619, in _exec
#   File "<frozen importlib._bootstrap_external>", line 835, in exec_module
#   File "<frozen importlib._bootstrap>", line 241, in _call_with_frames_removed
#   File "P:\68_PYT\m10a_Modul.py", line 16, in <module>
#     num  = 3_456 / 0
# ZeroDivisionError: division by zero
# >>>



#Výpis 16.4:	Ukázka zachycení a ošetření výjimky
############################################################################
def input_int() -> int:
    """Vrátí celé číslo zadané uživatelem z klávesnice.
       Základní podoba příkazu s větví try a jednou větví except.
    """
    while ...:
        try:
            x = int(input('Zadejte celé číslo: '))
            break   # Korektní zadání, můžeme cyklus ukončit
        except ValueError:
            print('To nebylo platné celé číslo! Zkuste to znovu...')
    return x
                                                                     #SYNC
print('\nZadali jste číslo:', input_int())
# Zadejte celé číslo: 0xabcd
# To nebylo platné celé číslo! Zkuste to znovu...
# Zadejte celé číslo: 0123
#
# Zadali jste číslo: 123
# >>>



#Výpis 16.5:	AHA-příklad používající příkaz try se všemi dostupnými větvemi
############################################################################
def input_int_full_try() -> int:
    """Vrátí celé číslo zadané uživatelem z klávesnice.
       Hlavním účelem je demonstrovat úplnou podobu příkazu
       a funkci jednotlivých větví při vyhození a nevyhození výjimky.
    """
    entered = False      # Ještě nebylo zadáno
    while not entered:   # Dokud nebude korektně zadáno
        try:
            x = int(input('----------------------\nZadejte celé číslo: '))
            print('++ Zadáno')
            entered = True    # Aby se cyklus ukončil
        except ValueError:
            print('-- To nebylo platné celé číslo! Zkuste to znovu...')
        else:
            print('ee Prochází se větev else')
        finally:
            print('ff Prochází se větev finally')
        print('cc Pokračujeme v těle cyklu - opakovat =', not entered)
    print('zz Cyklus ukončen, vrátili jsme se do těla funkce')
    return x
                                                                     #SYNC
print('\nZadali jste číslo:', input_int_full_try())
# ----------------------
# Zadejte celé číslo: 1.5
# -- To nebylo platné celé číslo! Zkuste to znovu...
# ff Prochází se větev finally
# cc Pokračujeme v těle cyklu - opakovat = True
# ----------------------
# Zadejte celé číslo: 3j
# -- To nebylo platné celé číslo! Zkuste to znovu...
# ff Prochází se větev finally
# cc Pokračujeme v těle cyklu - opakovat = True
# ----------------------
# Zadejte celé číslo: 999
# ++ Zadáno
# ee Prochází se větev else
# ff Prochází se větev finally
# cc Pokračujeme v těle cyklu - opakovat = False
# zz Cyklus ukončen, vrátili jsme se do těla funkce
#
# Zadali jste číslo: 999
# >>>



#Výpis 16.6:	Měření rychlosti počítače a přesnosti odhadu času
############################################################################
def kbd(times):
    """Umožňuje měřit přesnost uživatele při odhadu času
       a jako vedlejší efekt měří rychlost počítače.
    """
    from time import time
    for p in range(0, times):
        t1 = time()
        try:
            n = 0
            while True: n += 1
        except KeyboardInterrupt:
            t2 = time()
            print(p, '. pokus, ', n, ' běhů, ', s:=round(t2-t1, 3), ' sekund, ',
                  round(n/s/1e6, 3), ' běhů za mikrosekundu', sep='')
    print('Konec testu')

kbd(3)
# 0. pokus, 64419461 běhů, 2.934 sekund, 21.956 běhů za mikrosekundu
# 1. pokus, 75577335 běhů, 3.371 sekund, 22.42 běhů za mikrosekundu
# 2. pokus, 68387616 běhů, 2.927 sekund, 23.364 běhů za mikrosekundu
# Konec testu
# >>>



#Výpis 16.7:	Záludnosti větve finally
############################################################################
def demo_finally(arg) -> str:
    """Metoda demonstruje, chování bloku finally
    v některých nestandardních situacích.
    """
    sum = f'demo({arg}): '
    def add(a): nonlocal sum; sum += f'({a}) '
    try:
        if   arg > 0: add('run'); return sum
        elif arg < 0: add('exc'); raise Exception(sum)
    except Exception as ex:
        add('In exc')
        raise ex
    finally:
        add('In fin')
        if arg in (-1, 1):
            add('From fin')
            return sum
    return (f'Outside: {sum}')

for i in range(2, -3, -1): print(demo_finally(i))

# demo(2): (run)
# demo(1): (run) (In fin) (From fin)
# Outside: demo(0): (In fin)
# demo(-1): (exc) (In exc) (In fin) (From fin)
# Traceback (most recent call last):
#   File "<pyshell#22>", line 1, in <module>
#     for i in range(2, -3, -1): print(demo_finally(i))
#   File "<pyshell#20>", line 13, in demo_finally
#     raise ex
#   File "<pyshell#20>", line 10, in demo_finally
#     elif arg < 0: add('exc'); raise Exception(sum)
# Exception: demo(-2): (exc)
# >>>



#Výpis 16.8:	Funkce assert_stmt() demonstrující funkci příkazu assert
############################################################################
def assert_stmt(test, info=''):
    if __debug__:
        if not test:
            raise AssertionError(info)

# >>>



#Výpis 16.Y:	Popisek
############################################################################
dbg.stop_mod (0, __name__)
