#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/68_PYT/m17__Seznamy.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
17  Seznamy.

Co se v kapitole naučíte
Tato kapitola představuje seznamy jako základní proměnné posloupnosti dat.
Nejprve vysvětlí rozdíl mezi neměnnými a proměnnými objekty a pak probere
jednotlivé možnosti vytváření a případné modifikace seznamů.
Na závěr pak ukáže, jak se pracuje s vícerozměrnými seznamy.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
############################################################################



##Výpis 17.1:	Demonstrace neměnnosti objektů
############################################################################
int1 = int2 = 5
int1 += 1
print (f'{int1 = },   {int2 = }')
# int1 = 6,   int2 = 5
str1 = str2 = "Python"
str1 += " je skvělý"
print (f'{str1 = },   {str2 = }')
# str1 = 'Python je skvělý',   str2 = 'Python'
# >>>



#Výpis 17.2:	Vytváření seznamů pomocí literálů
############################################################################
lst = [];   lst
# []
(lst := [17, 'červen', (2**3 < 10), range(0, 100, 11), [1, 2, 3]])
# [17, 'červen', True, range(0, 100, 11), [1, 2, 3]]
# >>>



#Výpis 17.3:	Vytváření seznamů pomocí funkce list()
############################################################################
(lp := list('Python'))
# ['P', 'y', 't', 'h', 'o', 'n']
(lr := list(range(0, 55, 11)))
# [0, 11, 22, 33, 44]
list(lp, lr)
# Traceback (most recent call last):
#   File "<pyshell#9>", line 1, in <module>
#     list(lp, lr)
# TypeError: list expected at most 1 argument, got 2
list((lp, lr))
# [['P', 'y', 't', 'h', 'o', 'n'], [0, 11, 22, 33, 44]]
list()
# []
# >>>



#Výpis 17.4:	Vytváření seznamů z jiných seznamů pomocí sčítání a násobení
############################################################################
la = [1, 2];  lb = [10, 20]
(lab := la + lb)
# [1, 2, 10, 20]
(lac := 2*la + 2*lb)
# [1, 2, 1, 2, 10, 20, 10, 20]
la += lb;   la   # Zde to není výraz, zde se uvedení proměnné nevyhnu
# [1, 2, 10, 20]
lb *= 3;   lb    # I zde musím o zobrazení hodnoty požádat explicitně
# [10, 20, 10, 20, 10, 20]
# >>>



#Výpis 17.5:	Vytvoření seznamu pomocí generátorové notace
############################################################################
s = []
for c in 'Python': s.append(chr(ord(c)-1))

s
# ['O', 'x', 's', 'g', 'n', 'm']
[chr(ord(c)-1) for c in 'Python']
# ['O', 'x', 's', 'g', 'n', 'm']
[x*x for x in range(3, 30, 3)]
# [9, 36, 81, 144, 225, 324, 441, 576, 729]
[x*x for x in range(3, 30, 3) if x&1 == 1]
# [9, 81, 225, 441, 729]
(list3 := [x for x in range(3, 30, 3) if x&1 == 1])
# [3, 9, 15, 21, 27]
[[x, x*x] for x in list3]
# [[3, 9], [9, 81], [15, 225], [21, 441], [27, 729]]
[[x,y,z] for x in [0,1] for y in [0,1] for z in [0,1] if not(x==y==z)]
# [[0, 0, 1], [0, 1, 0], [0, 1, 1], [1, 0, 0], [1, 0, 1], [1, 1, 0]]
# >>>



#Výpis 17.6:	Použití funkcí append() a extend()
############################################################################
la = [1, 2];   lb = [10, 20];   lc = [11, 22]
lc.append(la);   lc
# [11, 22, [1, 2]]
lc.extend(lb);   lc
# [11, 22, [1, 2], 10, 20]
la.extend(range(3, 10, 3));   la
# [1, 2, 3, 6, 9]
la.append(range(3, 10, 3));   la
# [1, 2, 3, 6, 9, range(3, 10, 3)]
la += [111, 222, 333];   la
# [1, 2, 3, 6, 9, range(3, 10, 3), 111, 222, 333]
# >>>



#Výpis 17.7:	Demonstrace chování proměnných objektů
############################################################################
str1 = str2 = 'Jazyk Python'
lst1 = lst2 = 'Jazyk Python'.split()
print(f'{lst1 = },   {str1 = }\n{lst2 = },   {str2 = }')
# lst1 = ['Jazyk', 'Python'],   str1 = 'Jazyk Python'
# lst2 = ['Jazyk', 'Python'],   str2 = 'Jazyk Python'
str1 += ' je skvělý';   lst1 += 'je skvělý'.split()
print(f'{lst1 = },   {str1 = }\n{lst2 = },   {str2 = }')
# lst1 = ['Jazyk', 'Python', 'je', 'skvělý'],   str1 = 'Jazyk Python je skvělý'
# lst2 = ['Jazyk', 'Python', 'je', 'skvělý'],   str2 = 'Jazyk Python'
# >>>



#Výpis 17.8:	Postupné budování seznamu
############################################################################
lst = []
while ((x:=input('Hodnota: ')) != ''):
    lst.append(x)
    print(lst)

# Hodnota: ahoj
# ['ahoj']
# Hodnota: další
# ['ahoj', 'další']
# Hodnota: už končím
# ['ahoj', 'další', 'už končím']
# Hodnota:
# >>>



#Výpis 17.9:	Rozšiřování seznamu přičítáním
############################################################################
lst = [1, 2];   (lst1 := lst)
# [1, 2]
lst += [3, 4];    f'{lst=},  {lst1=}'
# 'lst=[1, 2, 3, 4],  lst1=[1, 2, 3, 4]'
lst1 is lst
# True
lst += range(0, 30, 11);   lst
# [1, 2, 3, 4, 0, 11, 22]
lst += 'ABC';   lst
# [1, 2, 3, 4, 0, 11, 22, 'A', 'B', 'C']
# >>>



#Výpis 17.10:	Chybné pokusy o rozšíření seznamu
############################################################################
lst += 99
# Traceback (most recent call last):
#   File "<pyshell#23>", line 1, in <module>
#     lst += 99
# TypeError: 'int' object is not iterable
lst + 'XYZ'
# Traceback (most recent call last):
#   File "<pyshell#24>", line 1, in <module>
#     lst + 'XYZ'
# TypeError: can only concatenate list (not "str") to list
lst
# [1, 2, 3, 4, 0, 11, 22, 'A', 'B', 'C']
lst + [77, 88, 99]
# [1, 2, 3, 4, 0, 11, 22, 'A', 'B', 'C', 77, 88, 99]
lst
# [1, 2, 3, 4, 0, 11, 22, 'A', 'B', 'C']
# >>>



#Výpis 17.11:	Ukázky použití modifikačních funkcí a metod pracujících s indexy
############################################################################
mis = list('Mississippi');   mis
# ['M', 'i', 's', 's', 'i', 's', 's', 'i', 'p', 'p', 'i']
mis.index('s'),   mis.index('s', 4)
# (2, 5)
mis.index('p', 0, 6)
# Traceback (most recent call last):
#   File "<pyshell#388>", line 1, in <module>
#     mis.index('p', 0, 6)
# ValueError: 'p' is not in list
lp = list('Python');   lp[1]='a';   lp[3]='t';   lp
# ['P', 'a', 't', 't', 'o', 'n']
lp.insert(3, 'h');   lp
# ['P', 'a', 't', 'h', 't', 'o', 'n']
lp.pop(4),   lp.pop(),   lp
# ('t', 'n', ['P', 'a', 't', 'h', 'o'])
mis.remove('i');   mis
# ['M', 's', 's', 'i', 's', 's', 'i', 'p', 'p', 'i']
mis.remove('i');   mis
# ['M', 's', 's', 's', 's', 'i', 'p', 'p', 'i']
# >>>



#Výpis 17.12:	Ukázky použití modifikačních metod pracujících s celým seznamem
############################################################################
lp = list('Python');   lp
# ['P', 'y', 't', 'h', 'o', 'n']
lp.reverse();   lp
# ['n', 'o', 'h', 't', 'y', 'P']
lp.sort();   lp
# ['P', 'h', 'n', 'o', 't', 'y']
lp.sort(reverse=True);   lp
# ['y', 't', 'o', 'n', 'h', 'P']
lp.sort(key=lambda char: ord(char) & 0x1F);   lp
# ['h', 'n', 'o', 'P', 't', 'y']
# >>>



#Výpis 17.13:	Modul m13a_Pascal s funkcemi pracujícími s vícerozměrnými seznamy
############################################################################

""" Je uloženo v souboru 
xxx 
"""



#Výpis 17.14:	Načtení modulu m17a_Pascal a prověření jeho funkce
############################################################################
from m17a_Pascal import *
# ===== Modul m17a_Pascal ===== START
# ===== Modul m17a_Pascal ===== STOP
print(printpas(pascal(7)))
#        1
#       1 1
#      1 2 1
#     1 3 3 1
#    1 4 6 4 1
#   1 5 10 10 5 1
#  1 6 15 20 15 6 1
#
# >>>



#Výpis 17.15:	Anotace odkazující na seznamy
############################################################################
def num2hex(lst:list[int]) -> list[str]:
    """Převádí seznam celých čísel na seznam stringů
    zapisujících daná čísla v hexadecimální (šestnáctkové) soustavě.
    """
    result = [hex(i) for i in lst]
    return result

num2hex([1, 10, 100, 1000])
# ['0x1', '0xa', '0x64', '0x3e8']
# >>>



#Výpis 17.0:	Popisek
############################################################################
dbg.stop_mod (0, __name__)
