#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ ó
#P:/64_PGM/64_PYT/m17a_Pascal.py
"""
Metoda vytvářející Pascalův trojúhelník a metoda, která jej tiskne.
"""
import dbg
dbg.start_mod(0, __name__)
############################################################################

def pascal(deep:int) -> None:
    """Vytvoří Pascalův trojúhelník zadané hloubky jako seznam seznamů."""
    if deep <= 0:
        raise Exception("Trojúhelník musí mít kladný počet řádků")
    pas = [[1]]     # První řádek trojúhelníku (řádek s indexem 0)
    if deep == 1: return pas
    pas.append([1,1])     # Druhý řádek trojúhelníku (řádek s indexem 1)
    # Každý prvek kromě počátečního a posledního, kterými jsou jedničky,
    # je součtem dvou prvků nad ním
    for r in range(2, deep):
        row =[1]    # Počáteční prvek v řádku
        for c in range(1, r):   # Cyklus přes všechny vnitřní prvky
            row.append(pas[r-1][c-1] + pas[r-1][c])
        row.append(1)       # Poslední prvek v řádku
        pas.append(row)     # Vytvořený řádek se přidá jako další
    return pas  # Vrací vytvořený Pascalův trojúhelník

def printpas(pas):
    """Vrátí string zobrazující zadaný Pascalův trojúhelník
       jako rovnoramenný trojúhelník.
    """
    deep = len(pas)     # Počet řádků trojúhelníku
    s    = ""           # String pro vytvářený trojúhelník
    for r in range(deep):   # Převádíme řádek za řádkem
        s += (deep-r)*' '   # Odsazení řádku se postupně zmenšuje
        for c in range(len(pas[r])):    # Přidáme jednotlivé položky
            s += f'{pas[r][c]} '        # oddělené jednou mezerou
        s += '\n'   # A řádek ukončíme
    return s



############################################################################
dbg.stop_mod(0, __name__)
