#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/68_PYT/m21__Rozšíření_definic_funkcí.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
21  Rozšíření definic funkcí.

Co se v kapitole naučíte
Tato kapitola navazuje na kapitolu 9  Pokročilé rysy funkcí na straně 163
a probírá rysy funkcí, k jejichž pochopení je třeba zvládnout
n-tice a slovníky. Nejprve upozorní na rozdíly mezi předáváním argumentů
odkazem a hodnotou a poté se soustředí především na problematiku
proměnného počtu argumentů.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
############################################################################



#Výpis 21.1:	Demonstrace chování programu při předávání argumentů hodnotou
############################################################################
def changeObject(lst: list):
    """Vliv změny předaného objektu při předávání hodnotou."""
    lst = [9, 8, 7]

lst = [1, 2, 3];   changeObject(lst);   lst
# [1, 2, 3]
def changeProperty(lst: list):
    """Vliv změny vlastností předaného objektu při předávání hodnotou."""
    lst[0] = 999

changeProperty(lst);   lst
# [999, 2, 3]
# >>>



#Výpis 21.2:	Definice a ukázky použití funkce gr
############################################################################
def gr(ones:int, multiples:int) -> range:
    """Vrátí generátor typu range, který vytvoří zadaný počet násobků
    čísla tvořeného zadaným počtem jedniček.
    """
    start = 1
    for i in range(1,ones): start = 10*start + 1
    return range(start, multiples*start+1, start)

set(gr(1, 3))
# {1, 2, 3}
list(gr(2, 4))
# [11, 22, 33, 44]
tuple(gr(3,5))
# (111, 222, 333, 444, 555)
# >>>



#Výpis 21.3:	Zpracování argumentů při použití hvězdičkového parametru
############################################################################
def f(a, b=20, *args, c=40):
    print(f'{a=}, {b=}, {args=}, {c=}')

f(1)
# a=1, b=20, args=(), c=40
f(1, 2, 3, 4, 5)
# a=1, b=2, args=(3, 4, 5), c=40
f(a=11)
# a=11, b=20, args=(), c=40
f(c=44, b=22, a=11)
# a=11, b=22, args=(), c=44
def avg(*num):
    sum = 0
    for x in num: sum += x
    return sum / len(num)

avg(11, 22, 33, 44, 55),    avg(*(2*x for x in gr(2, 5)))
# (33.0, 66.0)
# >>>



#Výpis 21.4:	Použití a zpracování hvězdičkového argumentu
############################################################################
f('a', *range(11,50,11), 'z')
# a='a', b=11, args=(22, 33, 44, 'z'), c=40
print('A', *range(11,40,11), 'B', *range(111,300,111), 'C')
# A 11 22 33 B 111 222 C
avg(11,22,33,44,55),   avg(*range(11,60,11))
# (33.0, 33.0)
lst = [3, 18, 3]
range(lst)
# Traceback (most recent call last):
#   File "<pyshell#8>", line 1, in <module>
#     range(lst)
# TypeError: 'list' object cannot be interpreted as an integer
range(*lst)
# range(3, 18, 3)
print(_, *_)
# range(3, 18, 3) 3 6 9 12 15
# >>>



#Výpis 21.5:	Zpracování argumentů při použití dvouhvězdičkového parametru
############################################################################
def ff(first, last, **info):
    print(f'Křestní:{first}, Příjmení:{last}', end='')
    for k, v in info.items():
        print(f', {k}:{v}', end='')
    print()

ff('Jan', 'Novák', Bydliště='Praha', Věk=47)
# Křestní:Jan, Příjmení:Novák, Bydliště:Praha, Věk:47
ff('Tomáš', 'Marný', Pozice='Analytik', Věk='29', ID=654321)
# Křestní:Tomáš, Příjmení:Marný, Pozice:Analytik, Věk:29, ID:654321
# >>>



#Výpis 21.6:	Zpracování dvouhvězdičkového argumentu
############################################################################
smeH = {'sep':'-', 'end':' HOTOVO\n'}
print(*gr(2,4), **smeH)
# 11-22-33-44 HOTOVO
sveO = {'sep':'>', 'end':' ¤ '}
print(*gr(3,3), **sveO); print(*gr(2,3), **smeH)
# 111>222>333 ¤ 11-22-33 HOTOVO
sxex = dict(smeH, fin='#')
print(1,2,3, **sxex)
# Traceback (most recent call last):
#   File "<pyshell#31>", line 1, in <module>
#     print(1,2,3, **sxex)
# TypeError: 'fin' is an invalid keyword argument for print()
# >>>



#Výpis 21.7:	Příklady zpracování argumentů inspirované [4]
############################################################################
def func(a, b, c, d): print(f'{a=}, {b=}, {c=}, {d=}')

func(10, 20, 30, 40)
# a=10, b=20, c=30, d=40
args = (11, 21);   args += (31, 41);   func(*args)
# a=11, b=21, c=31, d=41
args = {'d':42, 'c':32, 'b':22};   args['a'] = 12;   args
# {'d': 42, 'c': 32, 'b': 22, 'a': 12}
func(*args)  # "Jednohvězdičkově" rozbalovaný vrací klíče - func('d', 'c', 'b', 'a')
# a='d', b='c', c='b', d='a'
func(**args)  # "Dvouhvězdičkově" rozbalovaný - jako func(d=42, c=32, b=22, a=12)
# a=12, b=22, c=32, d=42
# V následujících příkladech zkrátím zápis použitím literálů
func(*(13, 23), **{'d':43, 'c':33}) # Totéž jako func(13, 23, d=43, c=33)
# a=13, b=23, c=33, d=43
func(14, *(24, 34), **{'d': 44})    # Totéž jako func(14, 24, 34, d=44)
# a=14, b=24, c=34, d=44
func(15, c=35, *(25,), **{'d': 45}) # Totéž jako func(15, 25, c=35, d=45)
# a=15, b=25, c=35, d=45
func(16, *(26, 36), d=46)           # Totéž jako func(16, 26, 36, d=46)
# a=16, b=26, c=36, d=46
func(17, *(27,), c=37, **{'d':47})  # Totéž jako func(17, 27, c=37, d=47)
# a=17, b=27, c=37, d=47
# >>>



#Výpis 21.8:	Možné použití hvězdičkových a dvojhvězdičkových argumentů
############################################################################
argz = dict(x=111, y=222, z=333, a=999);  args
# {'d': 42, 'c': 32, 'b': 22, 'a': 12}
lst = [*args, *argz];   lst
# ['d', 'c', 'b', 'a', 'x', 'y', 'z', 'a']
dct = {**args, **argz};    dct
# {'d': 42, 'c': 32, 'b': 22, 'a': 999, 'x': 111, 'y': 222, 'z': 333}
# >>>



##### Kapitola 21.6  Vestavěné funkce pracující s kontejnery
############################################################################

# all(iterable)
#---------------------------------------------------------------------------
def all(iterable):
    for element in iterable:
        if not element:
            return False
    return True


# any(iterable)
#---------------------------------------------------------------------------
def any(iterable):
    for element in iterable:
        if element:
            return True
    return False


# dir([object])
#---------------------------------------------------------------------------
# ================================ RESTART: Shell ================================
dir()
# ['__annotations__', '__builtins__', '__doc__', '__loader__', '__name__', '__package__', '__spec__']
text='Text';   číslo=123;   seznam=list('Python')
dir()
# ['__annotations__', '__builtins__', '__doc__', '__loader__', '__name__', '__package__', '__spec__', 'seznam', 'text', 'číslo']
# >>>


# enumerate(iterable, start=0)
#---------------------------------------------------------------------------
def enumerate(sequence, start=0):
    n = start
    for elem in sequence:
        yield n, elem
        n += 1
#---------------------------------------------------------------------------
období = ['Jaro', 'Léto', 'Podzim', 'Zima']
list(enumerate(období))
# [(0, 'Jaro'), (1, 'Léto'), (2, 'Podzim'), (3, 'Zima')]
list(enumerate(období, start=1))
# [(1, 'Jaro'), (2, 'Léto'), (3, 'Podzim'), (4, 'Zima')]
# >>>


# filter(function, iterable)
#---------------------------------------------------------------------------
def non_sys(text:str) -> bool:
    l   = len(text)
    sys = (l > 4)  and  (text[0]   == '_')  and  (text[1]   == '_')  \
                   and  (text[l-1] == '_')  and  (text[l-2] == '_')
    return not sys

print(*filter(non_sys, dir()))
# non_sys seznam text číslo
# >>>


# globals()
#---------------------------------------------------------------------------
globals()
# {'__name__': '__main__', '__doc__': None, '__package__': None, '__loader__': <class '_frozen_importlib.BuiltinImporter'>, '__spec__': None, '__annotations__': {}, '__builtins__': <module 'builtins' (built-in)>, 'text': 'Text', 'číslo': 123, 'seznam': ['P', 'y', 't', 'h', 'o', 'n'], 'non_sys': <function non_sys at 0x000001656EFBCE50>}
# >>>


# locals()
#---------------------------------------------------------------------------
def loc(param):  var='Proměnná';  print(locals())

loc('Parametr')
# {'param': 'Parametr', 'var': 'Proměnná'}
# >>>


# max(iterable, *[, key, default])
# max(arg1, arg2, *args[, key]
#---------------------------------------------------------------------------
max(*'Python')
# 'y'
max(100, 13, 35, 637, 982, 20, key=lambda n: n % 10)
# 637
# >>>


# min(iterable, *[, key, default])
# min(arg1, arg2, *args[, key]
#---------------------------------------------------------------------------
min(*'Python')
# 'P'
min(100, 13, 35, 637, 982, 20, key=lambda n: n % 10)
# 100
# >>>


# reversed(seq)
#---------------------------------------------------------------------------
list(reversed('Python'))
# ['n', 'o', 'h', 't', 'y', 'P']
# >>>


# sorted(iterable, *, key=None, reverse=False)
#---------------------------------------------------------------------------
sorted('Python');   sorted('Python',  reverse=True)
# ['P', 'h', 'n', 'o', 't', 'y']
# ['y', 't', 'o', 'n', 'h', 'P']
sorted({100, 13, 35, 637, 982, 20}, key=lambda n: n % 10)
# [100, 20, 982, 13, 35, 637]
# >>>


# sum(iterable, /, start=0)
#---------------------------------------------------------------------------
sum(range(1, 101))
# 5050
sum([[10,20],[33,44],[77,88]], start=[5])
# [5, 10, 20, 33, 44, 77, 88]
# >>>


# sum(iterable, /, start=0)
#---------------------------------------------------------------------------
def countingFunction():
    countingFunction.count += 1
    print('Byla jsem zavolána', countingFunction.count, 'krát')

countingFunction.count = 0
vars(countingFunction)
# {'count': 0}


# zip(*iterables)
#---------------------------------------------------------------------------
x = [0, 1, 2, 3];   y = [4, 5, 6];   z = [7, 8, 9, 10, 11, 12]
zipper = zip(x, y, z)
list(zipper)
# [(0, 4, 7), (1, 5, 8), (2, 6, 9)]
# >>>



#Výpis 21.Y:	Popisek
############################################################################
dbg.stop_mod (0, __name__)
