#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ ó
#P:/68_PYT/m24__Práce_se_soubory.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
24  Práce se soubory.

Co se v kapitole naučíte
Pod prací se soubory si jednou představíme práci se souborovým systémem
(tj. vytváření, vyhledávání, přejmenování a mazání souborů a složek),
podruhé práci s vlastními soubory (tj. jejich čtení a zapisování).
Tato kapitola vás seznámí s možnostmi Pythonu v obou zmíněných oblastech.
Ve výkladu se přitom omezí na operační systémy běžně rozšířené mezi
uživateli – Windows, macOS, Android a Linux.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
############################################################################



#Výpis 24.1:	Zjištění a změna aktuální složky
############################################################################
import os
os.getcwd()     # get current working directory
# 'P:\\68_PYT'
os.chdir('..')  # change directory
os.getcwd()
# 'P:\\'
os.chdir('68_PYT');   (cwd:=os.getcwd());   print(cwd)
# 'P:\\68_PYT'
# P:\68_PYT
os.listdir('..')
# ['!P_68_Python_3,10.bat', '68_PYT', '68_REC', '68_WRD', '68__cPython_3,10']
#!# os.listdir(r'P:\')
#   File "<stdin>", line 1
#     os.listdir(r'P:\')
#                ^
# SyntaxError: unterminated string literal (detected at line 1)
os.listdir('P:/')
# ['!P_68_Python_3,10.bat', '68_PYT', '68_REC', '68_WRD', '68__cPython_3,10']
# >>>



#Výpis 24.2:	Syntéza a analýza cest
############################################################################
data = os.path.join(cwd, 'DATA', 'data.txt');   data
# 'P:\\68_PYT\\DATA\\data.txt'
os.path.join(cwd, 'výplň', data);   os.path.join(data, cwd, 'výplň')
# 'P:\\68_PYT\\DATA\\data.txt'
# 'P:\\68_PYT\\výplň'
os.path.join(data, cwd, '/výplň')
# 'P:/výplň'
(dn := os.path.dirname(data)),   (bn := os.path.basename(data)); \
os.path.split(data);   os.path.splitext(data)
# ('P:\\68_PYT\\DATA', 'data.txt')
# ('P:\\68_PYT\\DATA', 'data.txt')
# ('P:\\68_PYT\\DATA\\data', '.txt')
os.path.split(dn);   os.path.split(bn);   os.path.splitext(dn)
# ('P:\\68_PYT', 'DATA')
# ('', 'data.txt')
# ('P:\\68_PYT\\DATA', '')
os.path.abspath('.');   os.path.relpath(data)
# 'P:\\68_PYT'
# 'DATA\\data.txt'
# >>>



#Výpis 24.3:	Vytváření a mazání složek
############################################################################
os.mkdir(tmp := '../TMP')
os.mkdir(tmp)
# Traceback (most recent call last):
#   File "<pyshell#51>", line 1, in <module>
#     os.mkdir(tmp)
# FileExistsError: [WinError 183] Nelze vytvořit soubor, který již existuje: '../TMP'
aaa = os.path.join(tmp, 'a/aa/aaa');   aaa
# '../TMP\\a/aa/aaa'
os.mkdir(aaa)
# Traceback (most recent call last):
#   File "<pyshell#53>", line 1, in <module>
#     os.mkdir(aaa)
# FileNotFoundError: [WinError 3] Systém nemůže nalézt uvedenou cestu: '../TMP\\a/aa/aaa'
os.makedirs(aaa);   os.path.exists(aaa)
# True
os.removedirs(aaa);   os.path.exists(tmp)
# False
# >>>



#Výpis 24.4:	Získání informací o souborech
############################################################################
print(f'{os.path.exists(dn)  }\t{dn   = !s}\n'
      f'{os.path.exists(data)}\t{data = !s}')
# False   dn   = P:\68_PYT\DATA
# False   data = P:\68_PYT\DATA\data.txt
os.mkdir(dn);   os.path.exists(dn),   os.path.exists(data)
# (True, False)
os.path.getsize('..'),   os.path.getsize('.'),   os.path.getsize(dn)
# (4096, 8192, 0)
m10a = 'm10a_Modul.py';   os.path.getsize(m10a)
# 1407
os.path.isdir('.'),   os.path.isfile('.')
# (True, False)
os.path.isdir(m10a),   os.path.isfile(m10a)
# (False, True)
os.path.isdir(data),   os.path.isfile(data)
# (False, False)
# >>>



#Výpis 24.5:	Otevření souboru
############################################################################
win = os.path.join(aaa, 'win.txt')
def print_paths():
    print(f'{os.path.exists(cwd) }\t{cwd  = !s}\n'
          f'{os.path.exists(dn)  }\t{dn   = !s}\n'
          f'{os.path.exists(data)}\t{data = !s}\n'
          f'{os.path.exists(tmp) }\t{tmp  = !s}\n'
          f'{os.path.exists(aaa) }\t{aaa  = !s}\n'
          f'{os.path.exists(win) }\t{win  = !s}')

print_paths()
# True    cwd  = P:\68_PYT
# True    dn   = P:\68_PYT\DATA
# False   data = P:\68_PYT\DATA\data.txt
# False   tmp  = ../TMP
# False   aaa  = ../TMP\a/aa/aaa
# False   win  = ../TMP\a/aa/aaa\win.txt
os.makedirs(aaa);   fw = open(win, 'w');   os.path.exists(win),   fw
# (True, <_io.TextIOWrapper name='../TMP\\a/aa/aaa\\win.txt' mode='w' encoding='cp1250'>)
fd = open(data, 'w', 1, 'utf8');   os.path.exists(data),   fd
# (True, <_io.TextIOWrapper name='P:\\68_PYT\\DATA\\data.txt' mode='w' encoding='utf8'>)
print_paths()
# True    cwd  = P:\68_PYT
# True    dn   = P:\68_PYT\DATA
# True    data = P:\68_PYT\DATA\data.txt
# True    tmp  = ../TMP
# True    aaa  = ../TMP\a/aa/aaa
# True    win  = ../TMP\a/aa/aaa\win.txt
# >>>



#Výpis 24.6:	Zápis dat, splachování a zavírání souborů
############################################################################
pangram = 'Příliš žluťoučký kůň úpěl ďábelské ó.'
print(pangram, file=fd);   print(pangram, file=fw)
fw.flush()
print(pangram, file=fd);   print(pangram, file=fw, flush=True)
print(file=fd);            print(file=fw, flush=True)
text = 'Copyright-©, Alpha-α, Beta-β, Smile-☺'
print(text, file=fd)
print(text, file=fw)
# Traceback (most recent call last):
#   File "<pyshell#88>", line 1, in <module>
#     print(text, file=fw)
#   File "C:\_PGM\Python\Python310\lib\encodings\cp1250.py", line 19, in encode
#     return codecs.charmap_encode(input,self.errors,encoding_table)[0]
# UnicodeEncodeError: 'charmap' codec can't encode character '\u03b1' in position 19: character maps to <undefined>
fd.close();   fw.close()
# >>>



#Výpis 24.7:	Čtení souborů
############################################################################
fd = open(data, 'r', 1, 'utf8')
while (line:=fd.readline()) != '':
    print(repr(line))

# 'Příliš žluťoučký kůň úpěl ďábelské ó.\n'
# 'Příliš žluťoučký kůň úpěl ďábelské ó.\n'
# '\n'
# 'Copyright-©, Alpha-α, Beta-β, Smile-☺\n'
fd.close()
fw = open(win)
while (line:=fw.read(59)) != '':
    print(repr(line))

# 'Příliš žluťoučký kůň úpěl ďábelské ó.\nPříliš žluťoučký kůň '
# 'úpěl ďábelské ó.\n\n'
fw.close()
fd = open(data, 'r', 1, 'utf8')
fd.readlines()
# ['Příliš žluťoučký kůň úpěl ďábelské ó.\n', 'Příliš žluťoučký kůň úpěl ďábelské ó.\n', '\n', 'Copyright-©, Alpha-α, Beta-β, Smile-☺\n']
fd.seek(0)   # Přesune aktuální pozici zpět na začátek souboru
# 0
for line in fd:
    print(repr(line[:10]), end=' === ')

# 'Příliš žlu' === 'Příliš žlu' === '\n' === 'Copyright-' ===
fd.close()
# >>>



#Výpis 24.Y:	Popisek
############################################################################
dbg.stop_mod (0, __name__)
