#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/68_PYT/m26__Třídy_a_jejich_instance.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
26  Třídy a jejich instance.

Co se v kapitole naučíte
Tato kapitola vás nejprve naučí definovat třídu a její atributy.
Ukáže vám, jak je možné atributy dodatečně přidávat, odebírat a měnit.
Poté vám vysvětlí, jak zařídit, aby třída správně vytvářela své instance,
jak ve třídě definovat vlastnosti a schopnosti jejích instancí
a jak s vytvořenými instancemi následně pracovat. Na závěr představí
některé speciální atributy a probere zvláštnosti zabudovaných tříd.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
############################################################################



#Výpis 26.1:	Definice třídy a jejích atributů
# Pro zanesení do knihy odebrat "@staticmethod" před C1.cm a C1.C11.cm
############################################################################
class C0: """Třída s prázdným tělem"""

class C1:
    """Třída definující svůj datový, funkční i typový atribut,
       tj. datovou proměnnou, metodu a třídu.
       Současně demonstruje spouštění příkazů v těle při definici.
    """
    print('START definice třídy C1')

    ca = 'Atribut ca třídy C1'

    def cm():
        """Statická metoda třídy C1 -- volá se "C1.cm()"."""
        print('Byla zavolána metoda C1.cm')

    class C11:
        """Vnitřní třída třídy C1 - oslovuje se "C1.C11".
           Má vlastní datový atribut a funkční atribut (metodu).
        """
        print('START definice třídy C1.C11')
        ca = 'Atribut ca třídy C1.C11'

        def cm():
            """Statická metoda třídy C11 - volá se "C1.C11.cm()"."""
            print('Byla zavolána metoda C1.C11.cm')

        print('KONEC definice třídy C1.C11')

    print('KONEC definice třídy C1')

# START definice třídy C1
# START definice třídy C1.C11
# KONEC definice třídy C1.C11
# KONEC definice třídy C1
f'{type(C0)=}, {type(C1)=}, {type(C1.C11)=}'
# "type(C0)=<class 'type'>, type(C1)=<class 'type'>, type(C1.C11)=<class 'type'>"
# >>>



#Výpis 26.2:	Práce s atributy objektu
############################################################################
C1.ca,   C1.C11.ca;   C1.cm();   C1.C11.cm()
# ('Atribut ca třídy C1', 'Atribut ca třídy C1.C11')
# Byla zavolána metoda C1.cm
# Byla zavolána metoda C1.C11.cm
C1.ca = 'Upravený atribut třídy C1'
f'{C1.ca =}'
# "C1.ca ='Upravený atribut třídy C1'"
# >>>



#Výpis 26.3:	Přidávání a odstraňování atributů objektu
############################################################################
#!# f"{C0.ca =}"
# Traceback (most recent call last):
#   File "<pyshell#20>", line 1, in <module>
#     f"{C0.ca =}"
# AttributeError: type object 'C0' has no attribute 'ca'
C0.ca = 'Atribut třídy C0'
f"{C0.ca =}"
# "C0.ca ='Atribut třídy C0'"
del C0.ca
#!# f"{C0.ca =}"
# Traceback (most recent call last):
#   File "<pyshell#27>", line 1, in <module>
#     f"{C0.ca =}"
# AttributeError: type object 'C0' has no attribute 'ca'
# >>>



#Výpis 26.4:	Přidávání a odstraňování metody
############################################################################
C0.cm = lambda: print('Byla zavolána metoda C0.cm')
C0.cm()
# Byla zavolána metoda C0.cm
def C0_cm():
    print(f'Byla zavolána verze nazvaná {C0.cm.__name__}')

C0.cm = C0_cm;    C0.cm()
# Byla zavolána verze nazvaná C0_cm.
C0_cm.__name__ = 'cm';    del C0_cm
C0_cm()
# Traceback (most recent call last):
#   File "<pyshell#29>", line 1, in <module>
#     C0_cm()
# NameError: name 'C0_cm' is not defined. Did you mean: 'c0_cm'?
C0.cm()
# Byla zavolána verze nazvaná cm.
# >>>



#Výpis 26.5:	Třída jako parametr funkce
############################################################################
def method(cls):
    print(f'Třída {cls.__name__} - ', end='')
    cls.cm()

method(C0);   method(C1);   method(C1.C11)
# Třída C0 - Byla zavolána verze nazvaná cm
# Třída C1 - Byla zavolána metoda C1.cm
# Třída C11 - Byla zavolána metoda C1.C11.cm
# >>>



#Výpis 26.6:	Vytvoření prvních instancí
############################################################################
c1a = C1()   # Vytvářím instanci třídy C1
print(f'{type(c1a) = }\n{     c1a  = }\n{C0()      = }')
# type(c1a) = <class '__main__.C1'>
#      c1a  = <__main__.C1 object at 0x000002044784D870>
# C0()      = <__main__.C0 object at 0x000002044784ED10>
# >>>



#Výpis 26.7:	Kvalifikace atributu třídy instancí
############################################################################
c1a.ca
# 'Upravený atribut třídy C1'
c1a.cm()
# Traceback (most recent call last):
#   File "<pyshell#32>", line 1, in <module>
#     c1a.cm()
# TypeError: cm() takes 0 positional arguments but 1 was given
C1.cm = staticmethod(C1.cm)
c1a.cm()
# Byla zavolána metoda C1.cm
# >>>



#Výpis 26.8:	Možná použití dekorátoru
############################################################################
class C26a:
    """Demonstrace použití dekorátorů."""
                                                                    #SYNC
    def inst(self): return f"{self.__class__.__name__}[{id(self):#_x}]"
                                                                    #SYNC
    def class0(cls): return f"Metoda třídy {cls.__name__} - PO"
    class0 = classmethod(class0)
                                                                    #SYNC
    @classmethod
    def class1(cls): return f"Metoda třídy {cls.__name__} - PŘED"
                                                                    #SYNC
    def static0(): return 'Statická - PO'
    static0 = staticmethod(static0)
                                                                    #SYNC
    @staticmethod
    def static1(): return 'Statická - PŘED'
                                                                    #SYNC
c = C26a();   C26a.inst(c),   c.inst()
# ('C26a[0x1d0_7df1_bc40]', 'C26a[0x1d0_7df1_bc40]')
C26a().class0(),    c.class0()
# ('Metoda třídy C26a - PO', 'Metoda třídy C26a - PO')
C26a().class1(),    c.class1()
# ('Metoda třídy C26a - PŘED', 'Metoda třídy C26a - PŘED')
C26a().static0(),   c.static0()
# ('Statická - PO', 'Statická - PO')
C26a().static1(),   c.static1()
# ('Statická - PŘED', 'Statická - PŘED')
# >>>



#Výpis 26.9	Přidání a použití instanční metody
############################################################################
def im(self): """Budoucí instanční metoda.""";   print(self.ia)

C1.im = im     # Odkaz na metodu přidám mezi třídní atributy
del im         # a proměnnou s odkazem na definici metody smažu
c1a.ia = 'Instanční atribut ia' # Připravím atribut tisknutý metodou
c1a.im();   C1.im(c1a)          # a metodu zavolám
# Instanční atribut ia
# Instanční atribut ia
# >>>



#Výpis 26.10:	Definice třídy C2
############################################################################
class C2:
    """Třída definující initor a podpisové metody."""

    ca = 'Atribut třídy C2'
    count = 0     # Inicializace počtu vytvořených instancí

    def __init__(self):
        """Initor instancí třídy C2."""
        C2.count += 1       # Vytvářím další instanci
        self.ID = C2.count  # Identifikační (rodné) číslo instance
        self.ia = f'Atribut {self.ID}. instance třídy C2'
        print(f'Vytvořena {self.ID}. instance třídy C2')

    def im(self, x):
        """Instanční metoda s jedním parametrem."""
        print(f'Metoda instance {self} s parametrem {x=}')

    def __repr__(this):
        """Definice systémového textového podpisu instance."""
        return f'<{C2.__module__}.C2_ {this.ID}>'

    def __str__(moje):
        """Definice uživatelského textového podpisu instance."""
        return (f'«C2_{moje.ID}»')

# >>>



#Výpis 26.11:	Vytváření instancí třídy C2 a používání jejich atributů
############################################################################
c2a=C2();   c2b=C2();   c2c=C2()
# Vytvořena 1. instance třídy C2
# Vytvořena 2. instance třídy C2
# Vytvořena 3. instance třídy C2
c2a,   c2b,   c2c
# (<__main__.C2_ 1>, <__main__.C2_ 2>, <__main__.C2_ 3>)
print(c2a,  c2b,  c2c, sep=', ')
# «C2_1», «C2_2», «C2_3»
print(f'{c2c.ca} -- {c2c.ia}')
# Atribut třídy C2 -- Atribut 3. instance třídy C2
c2b.im('přes instanci')
# Metoda instance «C2_2» s parametrem x='přes instanci'
C2.im(c2c, 'přes třídu')
# Metoda instance «C2_3» s parametrem x='přes třídu'
C2.im(C2(), 'čerstvě vytvořená')
# Vytvořena 4. instance třídy C2
# Metoda instance «C2_4» s parametrem x='čerstvě vytvořená'
# >>>



#Výpis 26.12:	Vytváření nových instančních datových atributů
############################################################################
c2a.ia2 = f"Druhý atribut instance {c2a}"
c2a.ia2
# 'Druhý atribut instance «C2_1»'
#!# c2b.ia2
# Traceback (most recent call last):
#   File "<pyshell#125>", line 1, in <module>
#     c2b.ia2
# AttributeError: 'C2' object has no attribute 'ia2'
# >>>


#Výpis 26.13:	Změny třídních datových atributů
############################################################################
C2.ca,   c2a.ca,   c2b.ca
# ('Atribut třídy C2', 'Atribut třídy C2', 'Atribut třídy C2')
C2.ca = 'Attr_C2.ca'
C2.ca,   c2a.ca,   c2b.ca
# ('Attr_C2.ca', 'Attr_C2.ca', 'Attr_C2.ca')
C2.ca2 = 'Attr_C2.ca2'
C2.ca2, c2a.ca2, c2b.ca2
# ('Attr_C2.ca2', 'Attr_C2.ca2', 'Attr_C2.ca2')
c2a.ca = 'Změna'
C2.ca,   c2a.ca,   c2b.ca
# ('Attr_C2.ca', 'Změna', 'Attr_C2.ca')
# >>>



#Výpis 26.14:	Třídní datový atribut jako implicitní hodnota instančního
############################################################################
class C3:
    """Experimentální třída pro demonstraci lokality atributů."""

    ca = 'Třídní'   # Implicitní hodnota stejnojmenných instančních atributů

    def __init__(self, ca = None):
        """Instanční atribut se vytváří pouze tehdy, je-li zadán argument ca."""
        if ca:  self.ca = ca

    def get_ca(self):
        """Vrací aktuálně platnou hodnotu ca - instanční či třídní."""
        return self.ca

    def __repr__(self):
        """Textový podpis instance používaný systémem."""
        return f'<C3: {self.ca=}>'

c30 = C3();   c31 = C3('Instanční')
print(f'{c30.ca=},   {c31.ca=}')
# c30.ca='Třídní',   c31.ca='Instanční'
print(f'Systém:   {c30=!r}   ###   {c31=!r}\n'
      f'Uživatel: {c30=!s}   ###   {c31=!s}')
# Systém:   c30=<C3: self.ca='Třídní'>   ###   c31=<C3: self.ca='Instanční'>
# Uživatel: c30=<C3: self.ca='Třídní'>   ###   c31=<C3: self.ca='Instanční'>
# >>>



#Výpis 26.15:	Zavádění nových třídních funkčních atributů
############################################################################
def im2(self, text):
    """Funkce určená k přidání do C2 jako nová metoda."""
    print('Druhá metoda instance', self, 's parametrem text =', repr(text))

C2.im2 = im2;    del im2    # Proměnnou s odkazem na funkci smaže
c2a.im2('první');    C2().im2('pátá');    C2.im2(c2c, 'třetí')
# Druhá metoda instance «C2_1» s parametrem text = 'první'
# Vytvořena 5. instance třídy C2
# Druhá metoda instance «C2_5» s parametrem text = 'pátá'
# Druhá metoda instance «C2_3» s parametrem text = 'třetí'
# >>>



#Výpis 26.16:	Zavádění nových instančních funkčních atributů
############################################################################
c2a.im3 = lambda self, arg: f'Metoda im3, {self=}, {arg=}'
#!# c2a.im3('Neprojde')
# Traceback (most recent call last):
#   File "<pyshell#161>", line 1, in <module>
#     c2a.im3('Neprojde')
# TypeError: <lambda>() missing 1 required positional argument: 'arg'
c2a.im3(c2b, 'Projde')
# "Metoda im3, self=<C2_2>, arg='Projde'"
C2.im3 = c2a.im3;   del c2a.im3
c2a.im3('Už projde')
# "Metoda im3, self=<C2_1>, arg='Už projde'"
# >>>



#Výpis 26.17:	Demonstrace nutnosti kvalifikace atributů
############################################################################
class C4:
    """Experimentální třída pro demonstraci lokality názvů"""

    atr = "Třídní"

    def mtd_loc():   atr    = 'Lokální';   return f'mtd_loc - {atr=}'
    def mtd_cls():   C4.atr = 'Změněný';   return f'mtd_cls - {C4.atr=}'
    def mtd_glo():                         return f'mtd_glo - {atr=}'

C4.atr,   C4.mtd_loc(),   C4.atr
# ('Třídní', "mtd_loc - atr='Lokální'", 'Třídní')
C4.atr,   C4.mtd_cls(),   C4.atr
# ('Třídní', "mtd_cls - C4.atr='Změněný'", 'Změněný')
#!# C4.mtd_glo()
# Traceback (most recent call last):
#   File "<pyshell#29>", line 1, in <module>
#     C4.mtd_glo()
#   File "<pyshell#28>", line 6, in mtd_glo
#     def mtd_glo():   return f'mtd_glo - {atr=}'
# NameError: name 'atr' is not defined. Did you mean: 'str'?
atr = 'Globální'
C4.mtd_glo()
# "mtd_glo - atr='Globální'"
# >>>



#Výpis 26.18:	Ukázky použití systémových atributů
############################################################################
def prDict(d):
    """Vytiskne položky zadaného slovníku, každou na samostatný řádek."""
    for k, v in d.items(): print(k, '=', v)

prDict(C2.__dict__)
# __module__ = __main__
# __doc__ = Třída definující initor a podpisové metody.
# ca = Atribut třídy C2
# count = 5
# __init__ = <function C2.__init__ at 0x0000020447866CB0>
# im = <function C2.im at 0x0000020447866D40>
# __repr__ = <function C2.__repr__ at 0x0000020447866DD0>
# __str__ = <function C2.__str__ at 0x0000020447866E60>
# __dict__ = <attribute '__dict__' of 'C2' objects>
# __weakref__ = <attribute '__weakref__' of 'C2' objects>
# ca2 = Attr_C2.ca2
# im2 = <function im2 at 0x0000020447867010>
# im3 = <function <lambda> at 0x00000204478A8430>
prDict(c2a.__dict__)
# ID = 1
# ia = Atribut 1. instance třídy C2
# ia2 = Druhý atribut instance «C2_1»
# ca = Změna
prDict(c2b.__dict__)
# ID = 2
# ia = Atribut 2. instance třídy C2
c2a.__class__,   c2a.__class__.__name__
# (<class '__main__.C2'>, 'C2')
# >>>



#Výpis 26.Y:	Popisek
############################################################################
dbg.stop_mod (0, __name__)
