#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/68_PYT/m29__Property_AbstrCls_DuckType.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
29  Vlastnosti, abstraktní třídy a kachní typování.

Co se v kapitole naučíte
Kapitola vám vysvětlí,

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
############################################################################



#Výpis 29.1:	Vlastnost jako instance třídy property
############################################################################
class C29a:
    def __init__(self, id, val):   self._id = id;   self._attr = val
    def __repr__(self):      return f"C29a_{self._id}({self._attr})"
    def _getAttr(self):      print(f"Čtení {self}:"); return self._attr
    def _setAttr(self, val): print(f"Zápis {self}:"); self._attr = val
    attr = property(_getAttr, _setAttr, doc='Demonstrační atribut')
    # def delAttr (self):      print(f"Mazat {self}:"); del self._attr
    # attr = property(getAttr, setAttr, delAttr, 'Demonstrační atribut')
                                                                    #SYNC
ca1 = C29a(1, 'Raz');   ca2 = C29a(2, 'Dva');   f'{ca1=}, {ca2=}'
# 'ca1=C29a_1(Raz), ca2=C29a_2(Dva)'
ca1.attr='One';   ca2.attr='Two';    f'{ca1=}, {ca2=}'
# Zápis C29a_1(Raz):
# Zápis C29a_2(Dva):
# 'ca1=C29a_1(One), ca2=C29a_2(Two)'
ca1.attr += ca2.attr;    f'{ca1=}, {ca2=}'
# Čtení C29a_1(One):
# Čtení C29a_2(Two):
# Zápis C29a_1(One):
# 'ca1=C29a_1(OneTwo), ca2=C29a_2(Two)'
help(C29a.attr)
# Help on property:

#     Demonstrační atribut

# >>>



#Výpis 29.2:	Využití lambda výrazů
############################################################################
class C29b:
    def __init__(self, x:float, y:float):   self._x = x;   self._y = y
    def __repr__(self): return f'C29b(x={self.x}, z={self.y})'
    x = property(lambda self: round(self._x), doc='Vodorovná souřadnice')
    y = property(lambda self: round(self._y), doc='Svislá souřadnice')
                                                                    #SYNC
cb = C29b(3.4, 5.6);    cb
# C29b(x=3, z=6)
cb.x = 1
# Traceback (most recent call last):
#   File "<pyshell#6>", line 1, in <module>
#     cb.x = 1
# AttributeError: can't set attribute 'x'
help(C29b)
# Help on class C29b in module __main__:
#
# class C29b(builtins.object)
#  |  C29b(x: float, y: float)
#  |
#  |  Methods defined here:
#  |
#  |  __init__(self, x: float, y: float)
#  |      Initialize self.  See help(type(self)) for accurate signature.
#  |
#  |  __repr__(self)
#  |      Return repr(self).
#  |
#  |  ----------------------------------------------------------------------
#  |  Readonly properties defined here:
#  |
#  |  x
#  |      Vodorovná souřadnice
#  |
#  |  y
#  |      Svislá souřadnice
#  |
#  |  ----------------------------------------------------------------------
#  |  Data descriptors defined here:
#  |
#  |  __dict__
#  |      dictionary for instance variables (if defined)
#  |
#  |  __weakref__
#  |      list of weak references to the object (if defined)
#
# >>>



#Výpis 29.3:	Důsledky změny třídního atributu definujícího vlastnost
############################################################################
cb
# C29b(x=3, z=6)
C29b.x = 0;    cb
# C29b(x=0, z=6)
cb.x = 1.2345;    cb
# C29b(x=1.2345, z=6)
C29b.y
# <property object at 0x000001F7F248AFC0>
cb.y = 0
# Traceback (most recent call last):
#   File "<pyshell#28>", line 1, in <module>
#     cb.y = 0
# AttributeError: can't set attribute 'y'
# >>>



#Výpis 29.4:	Zadání vlastnosti pomocí dekorátoru
############################################################################
class C29c:
    def __init__(self, id, val):
        self._id   = id
        self._attr = val
                                                                    #SYNC
    def __repr__(self):
        return f'C29c_{self._id}({self._attr})'
                                                                    #SYNC
    @property
    def attr(self):
        """Dokumentační komentář vlastnosti C29c.attr."""
        print(f'Čtení {self}.attr (= {self._attr})')
        return self._attr
                                                                    #SYNC
    @attr.setter
    def attr(self, val):
        print(f'Zápis {self}.attr ({self._attr}->{val})')
        self._attr = val
                                                                    #SYNC
    @attr.deleter
    def attr(self):
        print(f'Mažu {self}._attr (= {self._attr})')
        del self._attr
                                                                    #SYNC
# >>>



#Výpis 29.5:	Demonstrace použití vlastností instancí třídy C29c
############################################################################
cc1 = C29c(1, 'Raz');    cc2 = C29c(2, 'Dva');    cc1, cc2
# (C29c_1(Raz), C29c_2(Dva))
cc1.attr += cc2.attr;    cc1.attr, cc2.attr
# Čtení C29c_1(Raz).attr (= Raz)
# Čtení C29c_2(Dva).attr (= Dva)
# Zápis C29c_1(Raz).attr (Raz->RazDva)
# Čtení C29c_1(RazDva).attr (= RazDva)
# Čtení C29c_2(Dva).attr (= Dva)
# ('RazDva', 'Dva')
help(C29c.attr)
# Help on property:
#                                                                   #SYNC#
#     Dokumentační komentář vlastnosti C29c.attr.
#                                                                   #SYNC#
del cc2.attr
# Mažu C29c_2(Dva)._attr (= Dva)
cc2.attr
# Traceback (most recent call last):
#   File "<pyshell#26>", line 1, in <module>
#     cc2.attr
#   File "<pyshell#23>", line 12, in attr
#     print(f'Čtení {self}.attr (= {self._attr})')
#   File "<pyshell#23>", line 7, in __repr__
#     return f'C29c_{self._id}({self._attr})'
# AttributeError: 'C29c' object has no attribute '_attr'. Did you mean: 'attr'?
cc1.attr
# Čtení C29c_1(RazDva).attr (= RazDva)
# 'RazDva'
# >>>



#Výpis 29.6:	Definice formálně abstraktní třídy Matka29a bez abstraktních metod
############################################################################
from abc import ABC, abstractmethod

class Matka29a(ABC):
    """To, že je třída abstraktní, ještě neznamená, že nemůže mít instance.
    Zákaz vytvářet instance přijde až s definicí abstraktní metody.
    """

m29 = Matka29a();    m29
# <__main__.Matka29a object at 0x000001EBCFCAFCA0>
# >>>



#Výpis 29.7:	Definice abstraktní třídy Matka29b s abstraktní metodou
############################################################################
class Matka29b(ABC):
    """Tato třída definuje šablonovou metodu,
    takže už nemůže mít plnohodnotné instance.
    Ty mohou vystupovat pouze jako rodičovské podobjekty jejích potomků.
    """
    def template(self):
        """Šablonová metoda používající abstraktní metodu action().
        """
        print('Matka29b.template - spouštím metodu action')
        self.action()
        print('Matka29b.template - metoda action ukončena')
                                                                    #SYNC
    @abstractmethod
    def action(self):
        """Abstraktní metoda nepotřebuje funkční tělo;
        Lze ji definovat jako běžnou prázdnou metodu.
        Je však vhodné ji vybavit dokumentačním komentářem."""

Matka29b()
# Traceback (most recent call last):
#   File "<pyshell#35>", line 1, in <module>
#     Matka29b()
# TypeError: Can't instantiate abstract class Matka29b with abstract method action
# >>>



#Výpis 29.8:	Definice potomka abstraktní třídy nepřebíjejícího
#               abstraktní metodu
############################################################################
class Dcera29a(Matka29b):
    def template(self):
        print('Přebíjím rodičovskou metodu a nic nedělám')

Dcera29a()
# Traceback (most recent call last):
#   File "<pyshell#44>", line 1, in <module>
#     Dcera29a()
# TypeError: Can't instantiate abstract class Dcera29a with abstract method action
# >>>



#Výpis 29.9:	Definice třídy Dcera29b, jež je potomkem abstraktní třídy Matka29b
############################################################################
class Dcera29b(Matka29b):
    def action(self):
        print("---Spuštěna metoda Dcera29b.action")

d29b = Dcera29b();    d29b
# <__main__.Dcera29b object at 0x000001EBCFCAF880>
d29b.template()
# Matka29b.template - spouštím metodu action
# ---Spuštěna metoda Dcera29b.action
# Matka29b.template - metoda action ukončena
# >>>



#Výpis 29.10:	Definice dalších druhů abstraktních metod
############################################################################
class Demo29(ABC):
    """Demonstrace způsobu definice abstraktnosti dalších druhů metod.
    """
                                                                    #SYNC
    @staticmethod
    @abstractmethod
    def abs_stat():
        """Definice statické abstraktní metody."""
                                                                    #SYNC
    @classmethod
    @abstractmethod
    def abs_class(cls):
        """Definice třídní abstraktní metody."""
                                                                    #SYNC
    @property
    @abstractmethod
    def abs_pro(self):
        """Definice abstraktní čtecí přístupové metody."""
                                                                    #SYNC
    @abs_pro.setter
    @abstractmethod
    def abs_pro(self, value):
        """Definice abstraktní zapisovací přístupové metody."""
                                                                    #SYNC
    @abs_pro.deleter
    @abstractmethod
    def abs_pro(self):
        """Definice abstraktní odstraňovací přístupové metody."""
                                                                    #SYNC
    @abstractmethod
    def _get_prop(self):
        """Definice abstraktní čtecí přístupové metody."""
                                                                    #SYNC
    @abstractmethod
    def _set_prop(self, val):
        """Definice abstraktní čtecí zapisovací metody."""
                                                                    #SYNC
    prop = property(_get_prop, _set_prop, doc='Přímo definovaná vlastnost')
                                                                    #SYNC
# >>>



#Výpis 29.0:	Popisek
############################################################################
dbg.stop_mod (0, __name__)
