#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/68_PYT/m30__Další_objektové_konstrukce.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
X  NÁZEV_KAPITOLY.

Co se v kapitole naučíte
Kapitola vám vysvětlí,

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
############################################################################



#Výpis 30.1:	Vytvoření výčtového datového typu prostřednictvím
#               volání funkce Enum()a demonstrace vlastností daného typu
#               a jeho atributů–instancí
############################################################################
from enum import Enum
en = Enum('NumEN', 'NIL ONE TWO', start=0)
dir(en)
# ['NIL', 'ONE', 'TWO', '__class__', '__doc__', '__members__', '__module__']
en.__module__,   en.__class__,   en.__doc__
# ('__main__', <class 'enum.EnumType'>, 'An enumeration.')
en.__doc__ = 'První tři nezáporná celá čísla anglicky.'
en.__members__
# mappingproxy({'NIL': NumEN.NIL, 'ONE': NumEN.ONE, 'TWO': NumEN.TWO})
print(*(f'en({i})={en(i)}:{en(i)!r}' for i in range(len(en))), sep='  -  ')
#en(0)=NIL:NumEN.NIL  -  en(1)=ONE:NumEN.ONE  -  en(2)=TWO:NumEN.TWO
en['NIL'],   en['ONE'],   en['TWO'],   type(en(2)),   type(en.ONE)
# (NumEN.NIL, NumEN.ONE, NumEN.TWO, <enum 'NumEN'>, <enum 'NumEN'>)
print(*(f'{n!r} - {n.name} = {n.value}' for n in en), sep='   #   ')
# NumEN.NIL - NIL = 0   #   NumEN.ONE - ONE = 1   #   NumEN.TWO - TWO = 2
import dbg;   dbg.prDict(en)
# ##### Atributy objektu: <enum 'NumEN'>
# _generate_next_value_ = <function Enum._generate_next_value_ at 0x00000224BEC8D5A0>
# _new_member_ = <built-in method __new__ of type object at 0x00007FFE101AF780>
# _use_args_ = False
# _member_names_ = ['NIL', 'ONE', 'TWO']
# _member_map_ = {'NIL': NumEN.NIL, 'ONE': NumEN.ONE, 'TWO': NumEN.TWO}
# _value2member_map_ = {0: NumEN.NIL, 1: NumEN.ONE, 2: NumEN.TWO}
# _unhashable_values_ = []
# _member_type_ = <class 'object'>
# NIL = <enum.property object at 0x00000224BEC9C280>
# ONE = <enum.property object at 0x00000224BEC9C700>
# TWO = <enum.property object at 0x00000224BEC9C610>
# >>>



#Výpis 30.2:	Definice výčtového datového typu jako třídy
############################################################################
class NumCZ(Enum):
    """První tři nezáporná celá čísla česky."""
    RAZ = 1
    DVA = 2
    STR = 'CHYBA'
    NIC = 0

cz = NumCZ;    del NumCZ
print(*(f'cz({i})={cz(i)}:{cz(i)!r}' for i in range(len(cz)-1)), sep=' - ')
# cz(0)=NIC:NumCZ.NIC - cz(1)=RAZ:NumCZ.RAZ - cz(2)=DVA:NumCZ.DVA
print(f'cz("CHYBA") = {cz("CHYBA")} : {cz("CHYBA")!r}')
# cz("CHYBA") = STR : NumCZ.STR
# >>>



#Výpis 30.3:	Definice výčtového typu Směr demonstrujícího některé další možnosti
############################################################################
class Směr(Enum):
    VÝCHOD = V = 0
    SEVER  = S = 1
    ZÁPAD  = Z = 2
    JIH    = 3;  J = 3

    def _otoč_o(self, čtvrtotáček:int) -> 'Směr':
        """Vrátí směr otočený oproti svému o zadaný počet čtvrtotáček."""
        počet  = len(Směr)
        pořadí = self.value
        nové   = (pořadí + čtvrtotáček + počet) % počet
        return self._value2member_map_[nové]

    def vlevoVbok (self) -> Směr:    return self._otoč_o(+1)
    def vpravoVbok(self) -> Směr:    return self._otoč_o(-1)
    def čelemVzad (self) -> Směr:    return self._otoč_o(+2)

    def zkratka(self) -> str:    return self.name[0]

Směr.__members__
# mappingproxy({'VÝCHOD': Směr.VÝCHOD, 'V': Směr.VÝCHOD, 'SEVER': Směr.SEVER, 'S': Směr.SEVER, 'ZÁPAD': Směr.ZÁPAD, 'Z': Směr.ZÁPAD, 'JIH': Směr.JIH, 'J': Směr.JIH})
Směr.JIH is Směr.J
# True
dir(Směr)
# ['JIH', 'SEVER', 'VÝCHOD', 'ZÁPAD', '__class__', '__doc__', '__members__', '__module__']
print(*(f'{s.zkratka()}-{s.name},   ' for s in Směr), sep='')
# V-VÝCHOD,   S-SEVER,   Z-ZÁPAD,   J-JIH,
Směr.S, Směr.S.vlevoVbok(), Směr.S.vpravoVbok(), Směr.S.čelemVzad()
# (Směr.SEVER, Směr.ZÁPAD, Směr.VÝCHOD, Směr.JIH)
# >>>



#Výpis 30.4:	Automatické přiřazování obalovaných hodnot
############################################################################
from enum import auto
class E30a(Enum):
    E1 = auto()
    E2 = auto()
    E3 = auto()

E30b = Enum('E30b', 'E1, E2, E3')
E30a._value2member_map_;    E30b._value2member_map_
# {1: E30a.E1, 2: E30a.E2, 3: E30a.E3}
# {1: E30b.E1, 2: E30b.E2, 3: E30b.E3}
# >>>



#Výpis 30.5:	Poloautomatické  přiřazování obalovaných hodnot
############################################################################
class E30c(Enum):
    E0=0
    E1=auto();  E2=auto()
    E5=5;       E6=auto()
    E7=         E7a=auto()
    E8s='8';    E8=auto()

E30c._value2member_map_;    f'{E30c.E7a = }'
# {0: E30c.E0, 1: E30c.E1, 2: E30c.E2, 5: E30c.E5, 6: E30c.E6, 7: E30c.E7, '8': E30c.E8s, 8: E30c.E8}
# 'E30c.E7a = E30c.E7'
# >>>



#Výpis 30.6:	Definice datové třídy a její test
############################################################################
from dataclasses import dataclass
from typing      import ClassVar
@dataclass
class Item:
    """Instance reprezentují položky na skladě."""
    name:    str
    price:   float
    amount:  int = 0
    ordinal: ClassVar[int] = 0
                                                                    #SYNC
    def __post_init__(self):
        Item.ordinal += 1
        self.ID = Item.ordinal
                                                                    #SYNC
    def total(self) -> float:
        """Vrátí cenu uskladněných odpovídajících výrobků."""
        return self.price * self.amount

dbg.prDict(Item)
# ##### Atributy objektu: <class '__main__.Item'>
# amount = 0
# ordinal = 0
# total = <function Item.total at 0x0000020BDEBFB490>
dbg.prDict(Item("Máslo", 29, 5))
# ##### Atributy objektu: Item(name='Máslo', price=29, amount=5)
# name = Máslo
# price = 29
# amount = 5
# ID = 1
# >>>



#Výpis 30.7:	Získání hodnot v rámci vyhodnocování vzorů v příkazu match
############################################################################
from collections import namedtuple
Position = namedtuple('Position', 'x y', defaults=[0, 0])
p00=Position();   p01=Position(0,1);   p10=Position(1,0);   p23=Position(2,3)
print(p00, p01, p10, p23, sep='   ')
# Position(x=0, y=0)   Position(x=0, y=1)   Position(x=1, y=0)   Position(x=2, y=3)
def pos(arg:Position):
    print(f'Prověřujeme {arg}: ', end='')
    match arg:
        case Position(x=0, y=0):
            print('Bod je v počátku souřadnic')
        case Position(x=0, y=y):
            print(f'Bod je na ose y na souřadnici {y=}')
        case Position(x=x, y=0):
            print(f'Bod je na ose x na souřadnici {x=}')
        case Position(x,y):
            print(f'Bod je na souřadnicích {x=}, {y=}')
        case _:
            print('Zadaný objekt není instancí třídy Position')

pos(0);    pos(p00);    pos(p01);    pos(p10);    pos(p23)
# Prověřujeme 0: Zadaný objekt není instancí třídy Position
# Prověřujeme Position(x=0, y=0): Bod je v počátku souřadnic
# Prověřujeme Position(x=0, y=1): Bod je na ose y na souřadnici y=1
# Prověřujeme Position(x=1, y=0): Bod je na ose x na souřadnici x=1
# Prověřujeme Position(x=2, y=3): Bod je na souřadnicích x=2, y=3
# >>>



#Výpis 30.8:	Prověřování posloupností
############################################################################
def seq(arg:'Sequence') -> str:
    match arg:
        case []:
            r = 'prázdná posloupnost'
        case (x,):
            r = f'jednoprvková posloupnost obsahující {x}'
        case (x, *q, y):
            n = len(q)+2
            r = (f'{n}prvková posloupnost\n'
                 f'     začínající prvkem {x} a končící prvkem {y}\n'
                 f'     Vnitřek: {q}')
        case _:
            return 'Zadaný prvek nelze interpretovat jako posloupnost'
    result = f'Byla zadána {r}'
    return result
                                                                    #SYNC
print(seq('Posl'), seq((1,)), seq(Position(11,22)), seq([11,22,33,44,555]), sep='\n')
# Zadaný prvek nelze interpretovat jako posloupnost
# Byla zadána jednoprvková posloupnost obsahující 1
# Byla zadána 2prvková posloupnost
#      začínající prvkem 11 a končící prvkem 22
#      Vnitřek: []
# Byla zadána 5prvková posloupnost
#      začínající prvkem 11 a končící prvkem 555
#      Vnitřek: [22, 33, 44]
# >>>



#Výpis 30.9:	Použití vzoru s výběrem hodnot
############################################################################
def execute(*commands:str):
    for command in commands:
        match command.lower().split():
            case['konec']:
                print('Konec hry')
            case['vezmi', obj]:
                print(f'Hráč zvedl objekt: {obj}')
            case['jdi', ('východ' | 'sever' | 'západ' | 'jih') as direction]:
                print(f'Hráč se přesunul ve směru: {direction}')
            case['jdi', x]:
                print(f'Špatně zadaný směr: {x}')
            case _:
                print(f'Špatně zadaný příkaz: {command!r}')

execute('Jdi Sever', 'vezmi jablko', 'jdi domů', 'Končím', 'KONEC')
# Hráč se přesunul ve směru: sever
# Hráč zvedl objekt: jablko
# Špatně zadaný směr: domů
# Špatně zadaný příkaz: 'Končím'
# Konec hry
# >>>



#Výpis 30.0:	Popisek
############################################################################
dbg.stop_mod (0, __name__)
