#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/68_PYT/m35__Anotace.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
12  Anotace a přezdívky datových typů

Co se v kapitole naučíte
S anotacemi jsem vás stručně seznámil v podkapitole 12.7 Anotace na straně 199
a v předposledních podkapitolách kapitol o jednotlivých druzích kontejnerů.
Tato kapitole je představí trochu podrobněji. Protože je problematika
anotací velmi členitá, tak v řadě případů jen zájemcům naznačí,
jak a k čemu by se daly anotace využít.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
############################################################################



#Výpis 35.1:	Anotace parametrů funkce, její návratové hodnoty a atributů modulu
############################################################################
ai:int = "špatně"    # Anotace atributu spojená s inicializací
an:None              # Anotace atributu bez inicializace
an
# Traceback (most recent call last):
#   File "<stdin>", line 1, in <module>
# NameError: name 'an' is not defined. Did you mean: 'ai'?
def annFce(a:'něco', b, c:(1,10), d:type(ai)) -> dict[int,str]:
    """ Funkce demonstrující použití anotací."""
    return str(a) + str(b) + str(c) + str(d)

annFce(1, 2, 3, 4)
# '1234'
# >>>



#Výpis 35.2:	Zapamatované anotace při okamžitém vyhodnocení platné doposud
############################################################################
# V novějších verzích již nebude dostupné
atr:str = "atribut"
def annFce(a:'něco', b, c:(1,10), d:type(atr)) -> dict[int,str]: ...

__annotations__
# {'atr': <class 'str'>}
annFce.__annotations__
# {'a': 'něco', 'c': (1, 10), 'd': <class 'str'>, 'return': dict[int, str]}
# >>>



#Výpis 35.3:	Zapamatované anotace při odloženém vyhodnocení
#               plánované od verze 3.11
############################################################################
from __future__ import annotations  # Zapíná odložené vyhodnocení
atr:str = "atribut"
def annFce(a:'něco', b, c:(1,10), d:type(atr)) -> dict[int,str]: ...

__annotations__
# {'atr': 'str'}
annFce.__annotations__
# {'a': "'něco'", 'c': '(1, 10)', 'd': 'type(atr)', 'return': 'dict[int, str]'}
# >>>



#Výpis 35.4:	Co o anotacích prozradí nápověda
############################################################################
import __main__   # Jsme v interaktivním režimu => modul se jmenuje __main__
help(__main__)
# Help on module __main__:
#
# NAME
#     __main__
#
# FUNCTIONS
#     annFce(a: "'něco'", b, c: '(1, 10)', d: 'type(atr)') -> 'dict[int, str]'
#
# DATA
#     __annotations__ = {'atr': 'str'}
#     annotations = _Feature((3, 7, 0, 'beta', 1), (3, 11, 0, 'alpha', 0), 1...
#     atr = 'atribut'
#
# FILE
#     (built-in)
#
#
# >>>



#Výpis Definice a použití přezdívek datových typů
############################################################################
Vector = list[float]
def scale(scalar: float, vector: Vector) -> Vector:
    return [scalar * num for num in vector]

scale(2.0, [1.0, -4.2, 5.4])
# [2.0, -8.4, 10.8]
from typing import TypeAlias
VectorF:TypeAlias = list[float]
def double(vector:VectorF): return [2*x for x in vector]

double(_)    # Argumentem je výsledek minulého výpočtu
# [4.0, -16.8, 21.6]
# >>>



#Výpis 35.6:	Slučování datových typů
############################################################################
from typing import Union
numU = Union[int, float]        # Prostřednictvím funkce
numO:TypeAlias = int | float    # Prostřednictvím operátoru
numA == numU,    numA is numU   # Ekvivalentní, ale ne totožné
# (True, False)
isinstance(2, int|float),    isinstance(3.14, numU)
# (True, True)
# >>>



#Výpis 35.0:	Popisek
############################################################################
dbg.stop_mod (0, __name__)
