#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/68_PYT/m36a_Traced.py
"""
Modul definuje demonstrační jednoduchý dekorátor pro výklad dekorátorů.
"""
from dbg import DBG
if DBG>0: print(f'===== Modul {__name__} ===== START')
############################################################################

class traced:
    """Dekorátor zaznamenávající volání dekorované funkce."""

    level = 0           # Hloubka trasovaných vnoření volání
    indent = "   "      # Odsazovací řetězec

    def __init__(self, fce):
        """Initor - pamatuje si dekorovanou funkci."""
        while type(fce) == traced: print(f"{fce=}"); fce = fce.fce
        self.fce = fce

    def __call__(self, *args, **kwds):
        """Volání obálky s dekorovanou funkcí.
           Oznámí volání a ukončení dekorované funkce
           s naznačením hladiny vnoření."""
        print(f"{traced.level*traced.indent}>> {self.fce.__name__}("
              f"{args   if len(args)  >0 else ''}"
              f"{kwds if len(kwds)>0 else ''})")
        traced.level += 1
        result = self.fce(*args, **kwds)
        traced.level -= 1
        print(f"{traced.level*traced.indent}<< {self.fce.__name__}="
              f"{result}")
        return result


############################################################################
if DBG>0: print(f'===== Modul {__name__} ===== STOP')
