#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/68_PYT/m37a_Property.py
"""
Výpis 37.1: Ekvivalent definice vestavěné třídy property
"""
import dbg
dbg.start_mod(0, __name__)
############################################################################

class Property(object):
    """Emulace vestavěné třídy property převzatá z dokumentace."""

    def __init__(self, fget=None, fset=None, fdel=None, doc=None):
        self.fget = fget
        self.fset = fset
        self.fdel = fdel
        if doc is None and fget is not None:
            doc = fget.__doc__
        self.__doc__ = doc

    def __get__(self, obj, objtype=None):
        if obj is None:        # Není-li zadána instance,
            return self        # vlastnost vrátí sama sebe
        if self.fget is None:  # Není-li zadána zjišťovací metoda
            raise AttributeError("unreadable attribute")
        return self.fget(obj)

    def __set__(self, obj, value):
        if self.fset is None: # Není-li zadána nastavovací metoda
            raise AttributeError("can't set attribute")
        self.fset(obj, value)

    def __delete__(self, obj):
        if self.fdel is None: # Není-li zadána odstraňovací metoda
            raise AttributeError("can't delete attribute")
        self.fdel(obj)

    def getter(self, fget):
        return type(self)(fget, self.fset, self.fdel, self.__doc__)

    def setter(self, fset):
        return type(self)(self.fget, fset, self.fdel, self.__doc__)

    def deleter(self, fdel):
        return type(self)(self.fget, self.fset, fdel, self.__doc__)



############################################################################
dbg.stop_mod(0, __name__)
