#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/68_PYT/m39__Korutiny_vlákna_procesy.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
39  Korutiny, vlákna, procesy.

Co se v kapitole naučíte
Tato kapitola probírá další z témat, která by vydala na samostatnou publikaci.
Ukáže vám, jak je v Pythonu možné naprogramovat paralelní běh více činností.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
############################################################################



#Výpis 39.1:	Definice a použití jednoduchých korutin
############################################################################
import asyncio
import time
async def say_after(delay, what):
    print(f"Spuštěno v {time.strftime('%X')}: {delay=}, {what=}")
    await asyncio.sleep(delay)
    print(f"Tištěno v {time.strftime('%X')}: {what=}")

async def await39():
    print(f"await39: Start v {time.strftime('%X')}")
    await say_after(2, 'Dva')
    print(f"await39: Mezičas: {time.strftime('%X')}")
    await say_after(1, 'Raz')
    print(f"await39: Konec v {time.strftime('%X')}")

asyncio.run(await39())
# await39: Start v 13:28:59
# Spuštěno v 13:28:59: delay=2, what='Dva'
# Tištěno v 13:29:01: what='Dva'
# await39: Mezičas: 13:29:01
# Spuštěno v 13:29:01: delay=1, what='Raz'
# Tištěno v 13:29:02: what='Raz'
# await39: Konec v 13:29:02
# >>>



#Výpis 39.2:	Zabalení korutiny do instance třídy Task
############################################################################
async def task39():
    task2 = asyncio.create_task(say_after(2, 'Dva'))
    print('Mezi vytvořením task2 a task1')
    task1 = asyncio.create_task(say_after(1, 'Raz'))
    await asyncio.sleep(1)
    print(f"task39: Start v {time.strftime('%X')}")
    await task2
    print(f"task39: Mezičas: {time.strftime('%X')}")
    await task1
    print(f"task39: Konec v {time.strftime('%X')}")

asyncio.run(task39())
# Mezi vytvořením task2 a task1
# Spuštěno v 13:39:46: delay=2, what='Dva'
# Spuštěno v 13:39:46: delay=1, what='Raz'
# task39: Start v 13:39:47
# Tištěno v 13:39:47: what='Raz'
# Tištěno v 13:39:48: what='Dva'
# task39: Mezičas: 13:39:48
# task39: Konec v 13:39:48
# >>>



#Výpis 39.3:	Analýza datových typů
############################################################################
type(say_after), type(await39), type(task39)
# (<class 'function'>, <class 'function'>, <class 'function'>)
type(say_after(0, "")), type(await39()), type(task39())
#
# Warning (from warnings module):
#   File "<pyshell#9>", line 1
# RuntimeWarning: coroutine 'say_after' was never awaited
#
# Warning (from warnings module):
#   File "<pyshell#9>", line 1
# RuntimeWarning: coroutine 'await39' was never awaited
#
# Warning (from warnings module):
#   File "<pyshell#9>", line 1
# RuntimeWarning: coroutine 'task39' was never awaited
# (<class 'coroutine'>, <class 'coroutine'>, <class 'coroutine'>)
type(say_after(0, "")), type(await39()), type(task39())
# (<class 'coroutine'>, <class 'coroutine'>, <class 'coroutine'>)
# >>>



#Výpis 39.0:	Popisek
############################################################################
dbg.stop_mod (0, __name__)
